''This is to check or modify or delete if the access keys
''at end of tranlation strings are the same as in
''source strings and if not change to the same.
''Please use it only when you exactly know what it does!
''(c) 2007-2008 by gnatix (Last modified on 2008.02.24)
''2009-2019 Modified by wanfu (Last modified on 2019.09.16)

'#Uses ".\Module\modCheckCommon.bas"

Option Explicit

'Public Const Version = "2019.08.30"
'Public Const Build = "190830"
Private Const updateMainFile = "PSLCheckAccessKeys.bas"
Private Const updateINIFile = "PSLMacrosUpdates.rar"
Private Const updateINIMainUrl = "http://jp.wanfutrade.com/download/PSLMacrosUpdates.rar"
Private Const updateINIMinorUrl = "http://www.wanfutrade.com/software/hanhua/PSLMacrosUpdates.rar"
Private Const updateMainUrl = "http://jp.wanfutrade.com/download/PslAccessKey.rar"
Private Const updateMinorUrl = "http://www.wanfutrade.com/software/hanhua/PslAccessKey.rar"


' 
Sub Main
	Dim i As Long,j As Long,n As Long,Obj As Object,Temp As String,Stemp As Boolean
	Dim MsgList() As String,TempList() As String,trns As PslTransDisplay

	'ϵͳ
	On Error Resume Next
	Set Obj = CreateObject("WScript.Shell")
	If Obj Is Nothing Then
		MsgBox(Err.Description & " - " & "WScript.Shell",vbInformation)
		Exit Sub
	End If
	Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\Default"
	OSLanguage = Obj.RegRead(Temp)
	If OSLanguage = "" Then
		Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\InstallLanguage"
		OSLanguage = Obj.RegRead(Temp)
		If Err.Source = "WshShell.RegRead" Then
			MsgBox Err.Description,vbInformation
			Exit Sub
		End If
	End If
	Set Obj = Nothing
	' Adodb.Stream Ƿ
	Set Obj = CreateObject("Adodb.Stream")
	If Obj Is Nothing Then
		MsgBox Err.Description & " - " & "Adodb.Stream",vbInformation
		Exit Sub
	End If
	Set Obj = Nothing
	' Scripting.Dictionary Ƿ
	Set Obj = CreateObject("Scripting.Dictionary")
	If Obj Is Nothing Then
		MsgBox Err.Description & " - " & "Scripting.Dictionary",vbInformation
		Exit Sub
	End If
	Set Obj = Nothing
	' VBScript.RegExp Ƿ
	Set RegExp = CreateObject("VBScript.RegExp")
	If RegExp Is Nothing Then
		MsgBox Err.Description & " - " & "VBScript.RegExp",vbInformation
		Exit Sub
	End If
	On Error GoTo SysErrorMsg

	'ʼ
	ReDim Tools(3) As TOOLS_PROPERTIE,FileDataList(0) As String
	ReDim UIFileList(0) As UI_FILE,UIDataList(0) As INIFILE_DATA
	ReDim cSelected(26) As String,UpdateSet(5) As String,LFList(0) As LOG_FONT
	ReDim DefaultCheckList(1) As String,CheckList(0) As CHECK_SET,CheckList(0).LangPairList(0) 'As LANG_SET
	ReDim DefaultProjectList(4) As String,ProjectList(0) As CHECK_PROJECT_SET
	ReDim CheckCountList(6) As Integer,PslLangList(0) As LANG_SET

	'ת HEX ֵַΪ Long ʽģ壬תıת
	MsgList = ReSplit(ConvertStrHexRange,";")
	ReDim CheckHexStr(UBound(MsgList)) As CHECK_STRING_VALUE
	For i = 0 To UBound(MsgList)
		CheckHexStr(i).Range = Replace$(MsgList(i),",","")
		If i = 0 Then
			CheckHexStr(i).Range = "\\x[" & CheckHexStr(i).Range & "]{2}"
		ElseIf i = 1 Then
			CheckHexStr(i).Range = "\\u[" & CheckHexStr(i).Range & "]{4}"
		ElseIf i = 2 Then
			CheckHexStr(i).Range = "\\[" & CheckHexStr(i).Range & "]+"
		End If
		CheckHexStr(i).AscRange = "[" & Convert(Replace$(MsgList(i),",","")) & "]"
	Next i

	'תֵַΪʽģ壬ıʽȽ
	CheckSkipStr = ReSplit("[" & Replace$(Replace$(CheckStrHexRange,";","];["),",","]|[") & "]",";")

	'ȡ
	GetCheckSet("Option","")

	'ȡִ
	If GetUI(MacroLoc & "\Data\",cSelected(0),OSLanguage,UIDataList,UIFileList,LangFile) = False Then Exit Sub
	If getMsgList(UIDataList,MsgList,"Main",0) = False Then Exit Sub

	' PSL 汾
	If PSL.Version < 600 Then
		MsgBox MsgList(1),vbOkOnly+vbInformation,MsgList(0)
		Exit Sub
	End If

	'ⷭбǷ񱻼
	Set trns = PSL.ActiveTransDisplay
	If trns Is Nothing Then
		Set trn = PSL.ActiveTransList
		If trn Is Nothing Then
			MsgBox MsgList(2),vbOkOnly+vbInformation,MsgList(0)
			Exit Sub
		End If
	End If

	'ȡִ
	TempList = ReSplit(MsgList(4),";")
	DefaultCheckList(0) = TempList(0)
	DefaultCheckList(1) = TempList(1)
	TempList = ReSplit(MsgList(5),";")
	DefaultProjectList(0) = TempList(0)
	DefaultProjectList(1) = TempList(1)
	DefaultProjectList(2) = TempList(2)
	DefaultProjectList(3) = TempList(3)
	DefaultProjectList(4) = TempList(4)
	GetCheckSet("","")

	'ȡݲ°汾
	If CheckUpdate(UpdateSet,-2) = True Then Exit Sub

	'ʼ༭߲˵
	TempList = ReSplit(MsgList(3),";")
	Tools(0).sName = TempList(0)
	Tools(1).sName = TempList(1)
	Tools(2).sName = TempList(2)
	Tools(3).sName = TempList(3)
	Tools(1).FilePath = "notepad.exe"

	'ֹͣťʱʾԻϵϢ
	StopTitle = MsgList(27)
	StopMsg = MsgList(28)

	'ȡַб
	CodeList = getCodePageList(0,49)

	'鷭
	If UBound(CheckList) >= 0 Then
		If CheckCheckSet(CheckList) = False Then
			n = -1
		Else
			n = UBound(CheckList)
		End If
		For i = 0 To UBound(DefaultCheckList)
			Stemp = False
			For j = 0 To n
				If CheckList(j).Name = DefaultCheckList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve CheckList(n) As CHECK_SET
				CheckList(n) = DefaultCheckSet(DefaultCheckList(i),False)
				CheckList(n).Name = DefaultCheckList(i)
				CheckList(n).LangPairList = LangCodeList(DefaultCheckList(i),1,-1)
			End If
		Next i
		If CheckCheckSet(CheckList) = False Then
			If MsgBox(MsgList(6),vbYesNo+vbInformation,MsgList(0)) = vbNo Then Exit Sub
			CheckListBak = CheckList
			UpdateSetBak = UpdateSet
			Temp = cSelected(0)
			Call Settings(0,0)
			If Temp <> cSelected(0) Then getMsgList(UIDataList,MsgList,"Main",1)
		End If
	End If
	'鷭鷽
	If UBound(ProjectList) >= 0 Then
		If CheckArray(getSetNameList(ProjectList)) = False Then
			n = -1
		Else
			n = UBound(ProjectList)
		End If
		For i = 0 To UBound(DefaultProjectList)
			Stemp = False
			For j = 0 To n
				If ProjectList(j).Name = DefaultProjectList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve ProjectList(n) As CHECK_PROJECT_SET
				ProjectList(n) = DefaultCheckSet(DefaultProjectList(i),True)
				ProjectList(n).Name = DefaultProjectList(i)
			End If
		Next i
		If CheckArray(getSetNameList(ProjectList)) = False Then
			If MsgBox(MsgList(7),vbYesNo+vbInformation,MsgList(0)) = vbNo Then Exit Sub
			ProjectListBak = ProjectList
			Call Projects(0)
		End If
	End If

	'
	CheckListBak = CheckList
	ProjectListBak = ProjectList
	cSelectedBak = cSelected
	UpdateSetBak = UpdateSet
	LFListBak = LFList

	'ȡб
	With PSL.ActiveProject
		ReDim TempList(.TransLists.Count) As String
		n = 0
		For i = 1 To .TransLists.Count
			Set trn = .TransLists(i)
			If trn.IsOpen = True Then
				TempList(n) = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
				n = n + 1
			End If
		Next i
		If n > 0 Then
			Set trn = trns.String(1,pslDisplay).TransList
			ReDim Preserve TempList(n - 1) As String
		Else
			Set trn = PSL.ActiveTransList
			ReDim TempList(0) As String
			TempList(0) = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
		End If
	End With

	'Ի򲢼
	Do
		CheckListBak = CheckList
		ProjectListBak = ProjectList
		If MainDlg(Join$(TempList,";")) = False Then Exit Do
		If CheckStrings(trns) > -1 Then Exit Do
		CheckList = CheckListBak
		ProjectList = ProjectListBak
		ReDim CheckCountList(6) As Integer
	Loop
	Call ExitMacro(0)
	Exit Sub

	'ʾϢ
	SysErrorMsg:
	If Err.Source <> "ExitSub" Then Call sysErrorMassage(Err,0)
	Call ExitMacro(0)
End Sub


'ַ
Private Function CheckStrings(ByVal trns As PslTransDisplay) As Long
	Dim i As Long,trnID As Long,TransListOpen As Boolean
	Dim StringCount As Long,TransString As PslTransString
	Dim MsgList() As String,StrTypes As String
	Dim StartTime As Date,Temp As String
	If getMsgList(UIDataList,MsgList,"Main",1) = False Then Exit Function

	'תΪֵ
	ReDim SetList(UBound(cSelected)) As Integer
	For i = 3 To UBound(cSelected)
		SetList(i) = StrToLong(cSelected(i))
	Next i

	'ʾ򿪹رյķбҪ޸ĺɾ
	If trns Is Nothing Then
		Temp = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
		Select Case MsgBox(Replace(MsgList(9),"%s",Temp),vbYesNoCancel,MsgList(0))
		Case vbYes
			If trn.Open = False Then
				MsgBox Replace(MsgList(10),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			Else
				TransListOpen = True
			End If
		Case vbNo
			SetList(5) = 0
		Case Else
			CheckStrings = -1
			Exit Function
		End Select
	End If

	'ȡѡķ
	SetList(2) = -1
	For i = 0 To UBound(CheckList)
		If CheckList(i).Name = cSelected(2) Then
			SetList(2) = i
			Exit For
		End If
	Next i
	If SetList(2) = -1 Then Exit Function

	'תеתֵ
	CheckList(SetList(2)) = ConvertAndSortCheckSet(CheckList(SetList(2)))

	'ȡִ
	If SetList(7) = 1 Then StrTypes = "|Menu|"
	If SetList(8) = 1 Then StrTypes = StrTypes & "|Dialog|"
	If SetList(9)= 1 Then StrTypes = StrTypes & "|StringTable|"
	If SetList(10) = 1 Then StrTypes = StrTypes & "|AcceleratorTable|"
	If SetList(11) = 1 Then StrTypes = StrTypes & "|Version|"

	'Ƿѡ "ѡִ" Ҫִ
	If trns Is Nothing Then
		If TransListOpen = True Then
			If SetList(13) = 0 Then
				StringCount = trn.StringCount(pslDisplay)
			Else
				StringCount = trn.StringCount(pslSelection)
			End If
		Else
			StringCount = trn.StringCount
		End If
	Else
		If SetList(13) = 0 Then
			StringCount = trns.StringCount(pslDisplay)
		Else
			StringCount = trns.StringCount(pslSelection)
		End If
	End If

	'ʼÿִ
	PSL.OutputWnd.Clear
	PSL.Output MsgList(8)
	StartTime = Timer
	For i = 1 To StringCount
		'Ƿѡ "ѡִ" Ҫִ
		If trns Is Nothing Then
			If TransListOpen = True Then
				If SetList(13) = 0 Then
					Set TransString = trn.String(i,pslDisplay)
				Else
					Set TransString = trn.String(i,pslSelection)
				End If
			Else
				Set TransString = trn.String(i)
			End If
		Else
			If SetList(13) = 0 Then
				Set TransString = trns.String(i,pslDisplay)
			Else
				Set TransString = trns.String(i,pslSelection)
			End If
			Set trn = TransString.TransList
		End If
		'ȡб IDԱԷбĳЩֻһ
		If trn.ListID <> trnID Then
			trnID = trn.ListID
			'бĸʱԭʼбԶ
			If trn.SourceList.LastChange > trn.LastUpdate Then
				PSL.Output MsgList(11)
				If trn.Update = False Then
					Temp = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
					MsgBox Replace(MsgList(12),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
					GoTo Skip
				End If
			End If
			'üרõû
			If trn.Property(19980) <> "CheckAccessKeys" Then trn.Property(19980) = "CheckAccessKeys"
		End If
		CheckStrings = CheckStrings + CheckString(TransString,StrTypes,SetList,MsgList)
		Skip:
		'DoEvents 'תÿȨϵͳ¼
		If StopProcess(VK_ESCAPE) = True Then
			CheckStrings = -1
			Exit Function
		End If
	Next i
	'Ϣ
	i = CheckCountList(0) + CheckCountList(1) + CheckCountList(2) + CheckCountList(3) + _
		CheckCountList(4) + CheckCountList(5) + CheckCountList(6)
	PSL.Output CountMassage(CheckCountList,i,SetList(5))
	PSL.Output Format(DateAdd("s",Timer - StartTime,0),MsgList(13))
	If i = 0 And TransListOpen = True Then trn.Close
End Function


'Ի
Function MainDlg(ByVal Title As String) As Boolean
	Dim TempList() As String,MsgList() As String
	If getMsgList(UIDataList,MsgList,"MainDlg",0) = False Then Exit Function
	Begin Dialog UserDialog 660,518,MsgList(1),.MainDlgFunc ' %GRID:10,7,1,1
		TextBox 0,0,0,21,.SuppValueBox
		Text 20,7,620,14,Replace$(MsgList(0),"%s",Version),.Text1,2
		Text 20,28,620,32,MsgList(2),.Text2
		Text 20,63,620,14,MsgList(3) & Title,.Text3,2

		GroupBox 20,91,410,126,MsgList(4),.Configuration
		Text 40,112,70,14,MsgList(5),.Text4
		Text 40,140,70,14,MsgList(6),.Text5
		DropListBox 120,108,290,21,TempList(),.AutoList
		DropListBox 120,136,290,21,TempList(),.CheckList
		CheckBox 40,168,370,14,MsgList(7),.AutoChk
		CheckBox 40,189,370,14,MsgList(8),.AutoSelection

		GroupBox 440,91,200,126,MsgList(9),.CheckOption
		CheckBox 460,109,160,14,MsgList(10),.TagVer
		CheckBox 460,130,160,14,MsgList(11),.TagSet
		CheckBox 460,151,160,14,MsgList(12),.TagDate
		CheckBox 460,172,160,14,MsgList(13),.TagState
		CheckBox 460,193,160,14,MsgList(14),.TagAll

		GroupBox 20,231,620,49,MsgList(15),.ProjectSelection
		DropListBox 120,249,310,21,TempList(),.ProjectList
		PushButton 460,249,100,21,MsgList(16),.EditButton

		GroupBox 20,294,620,70,MsgList(17),.StrTypeSelection
		CheckBox 40,315,140,14,MsgList(18),.AllType
		CheckBox 190,315,140,14,MsgList(19),.Menu
		CheckBox 340,315,140,14,MsgList(20),.Dialog
		CheckBox 490,315,140,14,MsgList(21),.Strings
		CheckBox 40,336,140,14,MsgList(22),.AccTable
		CheckBox 190,336,140,14,MsgList(23),.Versions
		CheckBox 340,336,140,14,MsgList(24),.Other
		CheckBox 490,336,140,14,MsgList(25),.Seleted

		GroupBox 20,378,620,49,MsgList(26),.StrContSelection
		CheckBox 40,399,140,14,MsgList(27),.AllCont
		CheckBox 190,399,140,14,MsgList(28),.AccKey
		CheckBox 340,399,140,14,MsgList(29),.EndChar
		CheckBox 490,399,140,14,MsgList(30),.Acceler
		CheckBox 30,455,310,14,MsgList(31),.KeepSet
		CheckBox 340,434,300,14,MsgList(32),.NoCheckTag
		CheckBox 30,434,310,14,MsgList(33),.NoChangeState
		CheckBox 340,455,300,14,MsgList(34),.AutoRepStr

		PushButton 20,490,90,21,MsgList(35),.HelpButton
		PushButton 120,490,90,21,MsgList(36),.SetButton
		PushButton 220,490,110,21,MsgList(37),.SaveButton
		OKButton 450,490,90,21,.OKButton
		CancelButton 550,490,90,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	If Dialog(dlg) = 0 Then Exit Function
	MainDlg = True
End Function


'Ի
Private Function MainDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,n As Long
	Dim LangPair As LANG_SET,Temp As String,Stemp As Boolean
	Dim MsgList() As String,TempList() As String
	Select Case Action%
	Case 1
		DlgText "SuppValueBox",CStr$(SuppValue)
		DlgVisible "SuppValueBox",False
		TempList = getSetNameList(CheckList)
		DlgListBoxArray "AutoList",TempList()
		DlgListBoxArray "CheckList",TempList()
		TempList = getSetNameList(ProjectList)
		DlgListBoxArray "ProjectList",TempList()
		If CheckArray(cSelected) = True Then
			DlgText "AutoList",cSelected(1)
			DlgText "CheckList",cSelected(2)
			DlgValue "AutoChk",StrToLong(cSelected(3))
			DlgValue "AutoSelection",StrToLong(cSelected(4))
			DlgValue "ProjectList",StrToLong(cSelected(5))
			DlgValue "AllType",StrToLong(cSelected(6))
			DlgValue "Menu",StrToLong(cSelected(7))
			DlgValue "Dialog",StrToLong(cSelected(8))
			DlgValue "Strings",StrToLong(cSelected(9))
			DlgValue "AccTable",StrToLong(cSelected(10))
			DlgValue "Versions",StrToLong(cSelected(11))
			DlgValue "Other",StrToLong(cSelected(12))
			DlgValue "Seleted",StrToLong(cSelected(13))
			DlgValue "AllCont",StrToLong(cSelected(14))
			DlgValue "AccKey",StrToLong(cSelected(15))
			DlgValue "EndChar",StrToLong(cSelected(16))
			DlgValue "Acceler",StrToLong(cSelected(17))
			DlgValue "TagVer",StrToLong(cSelected(18))
			DlgValue "TagSet",StrToLong(cSelected(19))
			DlgValue "TagDate",StrToLong(cSelected(20))
			DlgValue "TagState",StrToLong(cSelected(21))
			DlgValue "TagAll",StrToLong(cSelected(22))
			DlgValue "NoCheckTag",StrToLong(cSelected(23))
			DlgValue "NoChangeState",StrToLong(cSelected(24))
			DlgValue "AutoRepStr",StrToLong(cSelected(25))
			DlgValue "KeepSet",StrToLong(cSelected(26))
		End If
		If DlgValue("AutoList") < 0 Then DlgValue "AutoList",0
		If DlgValue("CheckList") < 0 Then DlgValue "CheckList",0
		If DlgValue("ProjectList") < 0 Then DlgValue "ProjectList",0
		If DlgValue("AutoSelection") = 1 Then
			'ȡĿ
			With LangPair
				.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
				If .UseCode = "zh" Or .UseCode = "ja" Or .UseCode = "ko" Then .Name = "Asia"
				If .UseCode = "" Or .UseCode = "zh" Then
					.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
					Select Case .UseCode
					Case "zh-CHS" ,"zh-SG"
						.UseCode = "zh-CN"
					Case "zh-CHT", "zh-HK", "zh-MO"
						.UseCode = "zh-TW"
					End Select
				Else
					.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
				End If
				DlgValue "AutoList",getCheckID(CheckList,.UseCode,.Name)
				DlgValue "CheckList",getCheckID(CheckList,.UseCode,.Name)
				DlgEnable "AutoList",False
				DlgEnable "CheckList",False
				DlgEnable "AutoChk",False
			End With
		Else
			If DlgValue("AutoChk") = 1 Then DlgEnable "AutoList",False
		End If
		If CheckCheckSet(CheckList,DlgValue("CheckList")) = False Then DlgEnable "OKButton",False
		If DlgValue("AllType") + DlgValue("Menu") + DlgValue("Dialog") + DlgValue("Strings") + _
			DlgValue("AccTable") + DlgValue("Versions") + DlgValue("Other") + DlgValue("Seleted") = 0 Then
			DlgValue "Seleted",1
		End If
		If DlgValue("AllCont") + DlgValue("AccKey") + DlgValue("EndChar") + DlgValue("Acceler") = 0 Then
			DlgValue "AllCont",1
		End If
		If DlgValue("TagVer") + DlgValue("TagSet") + DlgValue("TagDate") + DlgValue("TagState") <> 0 Then
			DlgValue "TagAll",0
		End If
		If trn.IsOpen = False Then
			DlgEnable "Seleted",False
			DlgValue "Seleted",0
		End If
		DlgEnable "SaveButton",False
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		MainDlgFunc = True ' ֹ°ťرնԻ򴰿
		Select Case DlgItem$
		Case "CancelButton"
			cSelected = cSelectedBak
			MainDlgFunc = False
			Exit Function
		Case "HelpButton"
			If getMsgList(UIDataList,MsgList,"MainDlgFunc",0) = False Then Exit Function
			ReDim TempList(2) As String
			TempList(0) = MsgList(5)
			TempList(1) = MsgList(6)
			TempList(2) = MsgList(7)
			Select Case ShowPopupMenu(TempList,vbPopupUseRightButton)
			Case 0
				Call Help("MainHelp")
			Case 1
				i = Download(UpdateSet,UpdateSet(1),3,-2)
				If i = 0 Then Exit Function
				If UpdateSet(5) < Format(Date,"yyyy-MM-dd") Then
					Stemp = True
				ElseIf i = 3 And ArrayComp(UpdateSet,UpdateSetBak) = False Then
					Stemp = True
				End If
				If Stemp = True Then
					UpdateSet(5) = Format(Date,"yyyy-MM-dd")
					If WriteCheckSet(cWriteLoc,"Update") = False Then Exit Function
					UpdateSetBak(5) = UpdateSet(5)
				End If
				If i = 3 Then Call ExitMacro(1)
			Case 2
				Call Help("About")
			End Select
			Exit Function
		Case "OKButton"
			If getMsgList(UIDataList,MsgList,"MainDlgFunc",0) = False Then Exit Function
			'ִͺѡǷΪ
			i = DlgValue("AllType") + DlgValue("Menu") + DlgValue("Dialog") + DlgValue("Strings") + _
				DlgValue("AccTable") + DlgValue("Versions") + DlgValue("Other") + DlgValue("Seleted")
			n = DlgValue("AllCont") + DlgValue("AccKey") + DlgValue("EndChar") + DlgValue("Acceler")
			If i = 0 And n <> 0 Then
				MsgBox(MsgList(1),vbOkOnly+vbInformation,MsgList(0))
				Exit Function
			ElseIf i <> 0 And n = 0 Then
				MsgBox(MsgList(2),vbOkOnly+vbInformation,MsgList(0))
				Exit Function
			ElseIf i = 0 And n = 0 Then
				MsgBox(MsgList(3),vbOkOnly+vbInformation,MsgList(0))
				Exit Function
			End If
			'ѡ
			If DlgValue("KeepSet") = 1 Then
				If ArrayComp(cSelected,cSelectedBak) = True Then
					If WriteCheckSet(cWriteLoc,"Main") = False Then
						MsgBox Replace$(MsgList(4),"%s",cWriteLoc),vbOkOnly+vbInformation,MsgList(0)
						Exit Function
					End If
					cSelectedBak = cSelected
				End If
			End If
			CheckListBak = CheckList
			MainDlgFunc = False
			Exit Function
		Case "SaveButton"
			If ArrayComp(cSelected,cSelectedBak) = True Then
				If WriteCheckSet(cWriteLoc,"Main") = False Then
					If getMsgList(UIDataList,MsgList,"MainDlgFunc",0) = False Then Exit Function
					MsgBox Replace$(MsgList(4),"%s",cWriteLoc),vbOkOnly+vbInformation,MsgList(0)
				Else
					cSelectedBak = cSelected
					DlgEnable "SaveButton",False
				End If
			End If
			Exit Function
		Case "Menu", "Dialog", "Strings", "AccTable", "Versions", "Other"
			If DlgValue("Menu") + DlgValue("Dialog") + DlgValue("Strings") + DlgValue("AccTable") + _
				DlgValue("Versions") + DlgValue("Other") = 0 Then
				If DlgValue("Seleted") = 0 Then DlgValue "AllType",1
			Else
				DlgValue "AllType",0
				DlgValue "Seleted",0
			End If
		Case "AllType"
			If DlgValue("AllType") = 1 Then
				DlgValue "Menu",0
				DlgValue "Dialog",0
				DlgValue "Strings",0
				DlgValue "AccTable",0
				DlgValue "Versions",0
				DlgValue "Other",0
				DlgValue "Seleted",0
			End If
		Case "Seleted"
			If DlgValue("Seleted") = 1 Then
				DlgValue "AllType",0
				DlgValue "Menu",0
				DlgValue "Dialog",0
				DlgValue "Strings",0
				DlgValue "AccTable",0
				DlgValue "Versions",0
				DlgValue "Other",0
			Else
				DlgValue "AllType",1
			End If
		Case "AccKey", "EndChar", "Acceler"
			If DlgValue("AccKey") + DlgValue("EndChar") + DlgValue("Acceler") = 0 Then
				DlgValue "AllCont",1
			Else
				DlgValue "AllCont",0
			End If
		Case "AllCont"
			If DlgValue("AllCont") = 1 Then
				DlgValue "AccKey",0
				DlgValue "EndChar",0
				DlgValue "Acceler",0
			End If
		Case "TagVer", "TagSet", "TagDate", "TagState"
			If DlgValue("TagVer") + DlgValue("TagSet") + DlgValue("TagDate") + DlgValue("TagState") <> 0 Then
				DlgValue "TagAll",0
				DlgValue "NoCheckTag",0
			End If
		Case "TagAll"
			If DlgValue("TagAll") = 1 Then
				DlgValue "TagVer",0
				DlgValue "TagSet",0
				DlgValue "TagDate",0
				DlgValue "TagState",0
			End If
		Case "NoCheckTag"
			If DlgValue("NoCheckTag") = 1 Then
				DlgValue "TagVer",0
				DlgValue "TagSet",0
				DlgValue "TagDate",0
				DlgValue "TagState",0
				DlgValue "TagAll",1
			End If
		Case "AutoList", "CheckList"
			If DlgValue("AutoChk") = 1 Then
				DlgText "AutoList",DlgText("CheckList")
			End If
		Case "AutoChk"
			If DlgValue("AutoChk") = 1 Then
				DlgText "AutoList",DlgText("CheckList")
				DlgEnable "AutoList",False
			Else
				DlgText "AutoList",IIf(cSelected(1) = "",CheckList(0),cSelected(1))
				If DlgValue("AutoSelection") = 0 Then
					DlgEnable "AutoList",True
				End If
			End If
		Case "AutoSelection"
			If DlgValue("AutoSelection") = 1 Then
				'ȡĿ
				With LangPair
					.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
					If .UseCode = "zh" Or .UseCode = "ja" Or .UseCode = "ko" Then .Name = "Asia"
					If .UseCode = "" Or .UseCode = "zh" Then
						.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
						Select Case .UseCode
						Case "zh-CHS" ,"zh-SG"
							.UseCode = "zh-CN"
						Case "zh-CHT", "zh-HK", "zh-MO"
							.UseCode = "zh-TW"
						End Select
					Else
						.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
					End If
					DlgValue "AutoList",getCheckID(CheckList,.UseCode,.Name)
					DlgValue "CheckList",getCheckID(CheckList,.UseCode,.Name)
					DlgEnable "AutoList",False
					DlgEnable "CheckList",False
					DlgEnable "AutoChk",False
				End With
			Else
				If DlgValue("AutoChk") = 1 Then
					DlgText "AutoList",DlgText("CheckList")
					DlgEnable "AutoList",False
				Else
					DlgText "AutoList",IIf(cSelected(1) = "",CheckList(0),cSelected(1))
					DlgEnable "AutoList",True
				End If
				DlgEnable "CheckList",True
				DlgEnable "AutoChk",True
			End If
		Case "EditButton"
			Call Projects(DlgValue("ProjectList"))
			TempList = getSetNameList(ProjectList)
			DlgListBoxArray "ProjectList",TempList()
			DlgValue "ProjectList",StrToLong(cSelected(5))
			If DlgText("ProjectList") = "" Then DlgValue "ProjectList",0
		Case "SetButton"
			Temp = cSelected(0)
			ReDim tmpLFList(0) As LOG_FONT
			tmpLFList(0) = LFList(0)
			Call Settings(DlgValue("CheckList"),0)
			TempList = getSetNameList(CheckList)
			DlgListBoxArray "AutoList",TempList()
			DlgListBoxArray "CheckList",TempList()
			If DlgValue("AutoSelection") = 1 Then
				'ȡĿ
				With LangPair
					.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
					If .UseCode = "zh" Or .UseCode = "ja" Or .UseCode = "ko" Then .Name = "Asia"
					If .UseCode = "" Or .UseCode = "zh" Then
						.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
						Select Case .UseCode
						Case "zh-CHS" ,"zh-SG"
							.UseCode = "zh-CN"
						Case "zh-CHT", "zh-HK", "zh-MO"
							.UseCode = "zh-TW"
						End Select
					Else
						.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
					End If
					DlgValue "AutoList",getCheckID(CheckList,.UseCode,.Name)
					DlgValue "CheckList",getCheckID(CheckList,.UseCode,.Name)
				End With
			Else
				DlgText "AutoList",cSelected(1)
				DlgText "CheckList",cSelected(2)
			End If
			If DlgText("AutoList") = "" Then DlgValue "AutoList",0
			If DlgText("CheckList") = "" Then DlgValue "CheckList",0
			If Temp <> cSelected(0) Then
				If getMsgList(UIDataList,MsgList,"MainDlg",1) = True Then
					n = 0
					With PSL.ActiveProject
						ReDim TempList(PSL.ActiveProject.TransLists.Count) As String
						For i = 1 To .TransLists.Count
							If .TransLists(i).IsOpen = True Then
							TempList(n) = .TransLists(i).Title & " - " & _
										  PSL.GetLangCode(.TransLists(i).Language.LangID,pslCodeText)
								n = n + 1
							End If
						Next i
						If n > 0 Then
							ReDim Preserve TempList(n - 1) As String
						Else
							ReDim TempList(0) As String
							TempList(0) = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
						End If
					End With
					DlgText -1,MsgList(1)
					DlgText "Text1",Replace$(MsgList(0),"%s",Version)
					DlgText "Text2",MsgList(2)
					DlgText "Text3",MsgList(3) & Join(TempList,";")

					DlgText "Configuration",MsgList(4)
					DlgText "Text4",MsgList(5)
					DlgText "Text5",MsgList(6)
					TempList = getSetNameList(CheckList)
					DlgListBoxArray "AutoList",TempList()
					DlgText "AutoList",cSelected(1)
					DlgListBoxArray "AutoList",TempList()
					DlgText "CheckList",cSelected(2)

					DlgText "AutoChk",MsgList(7)
					DlgText "AutoSelection",MsgList(8)

					DlgText "CheckOption",MsgList(9)
					DlgText "TagVer",MsgList(10)
					DlgText "TagSet",MsgList(11)
					DlgText "TagDate",MsgList(12)
					DlgText "TagState",MsgList(13)
					DlgText "TagAll",MsgList(14)

					DlgText "ProjectSelection",MsgList(15)
					DlgText "EditButton",MsgList(16)
					TempList = getSetNameList(ProjectList)
					DlgListBoxArray "ProjectList",TempList()
					DlgValue "ProjectList",StrToLong(cSelected(5))

					DlgText "StrTypeSelection",MsgList(17)
					DlgText "AllType",MsgList(18)
					DlgText "Menu",MsgList(19)
					DlgText "Dialog",MsgList(20)
					DlgText "Strings",MsgList(21)
					DlgText "AccTable",MsgList(22)
					DlgText "Versions",MsgList(23)
					DlgText "Other",MsgList(24)
					DlgText "Seleted",MsgList(25)

					DlgText "StrContSelection",MsgList(26)
					DlgText "AllCont",MsgList(27)
					DlgText "AccKey",MsgList(28)
					DlgText "EndChar",MsgList(29)
					DlgText "Acceler",MsgList(30)
					DlgText "KeepSet",MsgList(31)
					DlgText "NoCheckTag",MsgList(32)
					DlgText "NoChangeState",MsgList(33)
					DlgText "AutoRepStr",MsgList(34)

					DlgText "HelpButton",MsgList(35)
					DlgText "SetButton",MsgList(36)
					DlgText "SaveButton",MsgList(37)
				End If
			End If
			DlgEnable "OKButton",CheckCheckSet(CheckList,DlgValue("CheckList"))
			'ж϶ԻǷѱı
			If FontComp(LFList(0),tmpLFList(0)) = True Then
				n = CLng(DlgText("SuppValueBox"))
				j = CreateFont(n,LFList(0))
				If j = 0 Then Exit Function
				For i = 0 To DlgCount() - 1
					SendMessageLNG(GetDlgItem(n,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
				Next i
				DrawWindow(n,j)
			End If
		End Select
		cSelected(1) = DlgText("AutoList")
		cSelected(2) = DlgText("CheckList")
		cSelected(3) = DlgValue("AutoChk")
		cSelected(4) = DlgValue("AutoSelection")
		cSelected(5) = DlgValue("ProjectList")
		cSelected(6) = DlgValue("AllType")
		cSelected(7) = DlgValue("Menu")
		cSelected(8) = DlgValue("Dialog")
		cSelected(9) =  DlgValue("Strings")
		cSelected(10) = DlgValue("AccTable")
		cSelected(11) = DlgValue("Versions")
		cSelected(12) = DlgValue("Other")
		cSelected(13) = DlgValue("Seleted")
		cSelected(14) = DlgValue("AllCont")
		cSelected(15) = DlgValue("AccKey")
		cSelected(16) = DlgValue("EndChar")
		cSelected(17) = DlgValue("Acceler")
		cSelected(18) = DlgValue("TagVer")
		cSelected(19) = DlgValue("TagSet")
		cSelected(20) = DlgValue("TagDate")
		cSelected(21) = DlgValue("TagState")
		cSelected(22) = DlgValue("TagAll")
		cSelected(23) = DlgValue("NoCheckTag")
		cSelected(24) = DlgValue("NoChangeState")
		cSelected(25) = DlgValue("AutoRepStr")
		cSelected(26) = DlgValue("KeepSet")
		DlgEnable "SaveButton",ArrayComp(cSelected,cSelectedBak,"1-" & CStr$(UBound(cSelected)))
	End Select
End Function


'Զ
Function Projects(ByVal ProjectID As Long) As Long
	Dim MsgList() As String,TempList(2) As String,TempArry() As String
	Projects = ProjectID
	If getMsgList(UIDataList,MsgList,"Projects",1) = False Then Exit Function
	TempArry = getSetNameList(ProjectList)
	TempList(0) = MsgList(23)
	TempList(1) = MsgList(24)
	TempList(2) = MsgList(25)
	Begin Dialog UserDialog 660,518,MsgList(0),.ProjectsFunc ' %GRID:10,7,1,1
		Text 20,7,620,28,MsgList(1),.MainText

		GroupBox 20,42,360,77,MsgList(2),.GroupBox1
		DropListBox 40,63,290,21,TempArry(),.ProjectList
		PushButton 330,63,30,21,MsgList(3),.NextSetType
		PushButton 40,91,90,21,MsgList(4),.AddButton
		PushButton 155,91,90,21,MsgList(5),.ChangButton
		PushButton 270,91,90,21,MsgList(6),.DelButton

		GroupBox 390,42,250,77,MsgList(7),.GroupBox2
		OptionGroup .cWriteType
			OptionButton 410,66,100,14,MsgList(8),.cWriteToFile
			OptionButton 520,66,100,14,MsgList(9),.cWriteToRegistry
		PushButton 410,91,90,21,MsgList(10),.ImportButton
		PushButton 530,91,90,21,MsgList(11),.ExportButton

		GroupBox 20,133,620,154,MsgList(12),.GroupBox3
		Text 40,154,160,14,MsgList(13),.ItemText
		Text 210,154,130,14,MsgList(14),.inSourceText
		Text 350,154,130,14,MsgList(15),.inTargetText
		Text 490,154,130,14,MsgList(16),.inBothText
		Text 40,178,160,14,MsgList(17),.PreSpaceText
		Text 40,199,160,14,MsgList(18),.EndSpaceText
		Text 40,220,160,14,MsgList(19),.acckeyText
		Text 40,241,160,14,MsgList(20),.EndStringText
		Text 40,262,160,14,MsgList(21),.ShortcutText
		CheckBox 210,175,120,21,MsgList(22),.PreSpaceinSourceBox
		CheckBox 350,175,120,21,MsgList(25),.PreSpaceinTargetBox
		DropListBox 490,175,130,21,TempList(),.PreSpaceinBothBox
		CheckBox 210,196,120,21,MsgList(22),.EndSpaceinSourceBox
		CheckBox 350,196,120,21,MsgList(25),.EndSpaceinTargetBox
		DropListBox 490,196,130,21,TempList(),.EndSpaceinBothBox
		CheckBox 210,217,120,21,MsgList(22),.AcckeyinSourceBox
		CheckBox 350,217,120,21,MsgList(25),.AcckeyinTargetBox
		DropListBox 490,217,130,21,TempList(),.AcckeyinBothBox
		CheckBox 210,238,120,21,MsgList(22),.EndStringinSourceBox
		CheckBox 350,238,120,21,MsgList(25),.EndStringinTargetBox
		DropListBox 490,238,130,21,TempList(),.EndStringinBothBox
		CheckBox 210,259,120,21,MsgList(22),.ShortcutinSourceBox
		CheckBox 350,259,120,21,MsgList(25),.ShortcutinTargetBox
		DropListBox 490,259,130,21,TempList(),.ShortcutinBothBox

		GroupBox 20,301,620,175,MsgList(26),.GroupBox4
		CheckBox 40,322,580,14,MsgList(27),.DelSpaceBox
		CheckBox 40,343,580,14,MsgList(28),.SpaceForEnAndAsiaBox
		CheckBox 40,364,580,14,MsgList(29),.EnableStringSplitBox
		CheckBox 40,385,580,14,MsgList(30),.TranEndStringBox
		CheckBox 40,406,580,14,MsgList(31),.AcckeyInShortcutBox
		CheckBox 40,427,580,14,MsgList(33),.ApplyCheckResultBox
		CheckBox 40,448,580,14,MsgList(32),.ShowOriginalTranBox

		PushButton 20,490,90,21,MsgList(34),.HelpButton
		PushButton 120,490,100,21,MsgList(35),.ResetButton
		PushButton 330,490,90,21,MsgList(36),.TestButton
		PushButton 230,490,90,21,MsgList(37),.CleanButton
		OKButton 460,490,90,21,.OKButton
		CancelButton 560,490,80,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.ProjectList = ProjectID
	If Dialog(dlg) = 0 Then Exit Function
	Projects = dlg.ProjectList
End Function


Private Function ProjectsFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,n As Long
	Dim TempList() As String,MsgList() As String,Temp As String
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		Select Case cWriteLoc
		Case CheckFilePath
			DlgValue "cWriteType",0
		Case CheckRegKey
			DlgValue "cWriteType",1
		Case Else
			DlgValue "cWriteType",0
		End Select

		j = DlgValue("ProjectList")
		TempList = getSetNameList(ProjectList)
		If j < 0 Then
			DlgValue "ProjectList",0
			j = 0
		End If
		If CheckArray(TempList) = True Then
			With ProjectList(j)
				DlgValue "PreSpaceinSourceBox",.PreSpaceInSource
				DlgValue "PreSpaceinTargetBox",.PreSpaceInTarget
				DlgValue "PreSpaceinBothBox",.PreSpaceInBoth
				DlgValue "EndSpaceinSourceBox",.EndSpaceInSource
				DlgValue "EndSpaceinTargetBox",.EndSpaceInTarget
				DlgValue "EndSpaceinBothBox",.EndSpaceInBoth
				DlgValue "AcckeyinSourceBox",.AcckeyInSource
				DlgValue "AcckeyinTargetBox",.AcckeyInTarget
				DlgValue "AcckeyinBothBox",.AcckeyInBoth
				DlgValue "EndStringinSourceBox",.EndStrInSource
				DlgValue "EndStringinTargetBox",.EndStrInTarget
				DlgValue "EndStringinBothBox",.EndStrInBoth
				DlgValue "ShortcutinSourceBox",.ShortcutInSource
				DlgValue "ShortcutinTargetBox",.ShortcutInTarget
				DlgValue "ShortcutinBothBox",.ShortcutInBoth
				DlgValue "DelSpaceBox",.DelSpace
				DlgValue "EnableStringSplitBox",.EnableStrSplit
				DlgValue "TranEndStringBox",.TranEndStr
				DlgValue "AcckeyInShortcutBox",.UseAcckeyInShortcut
				DlgValue "ShowOriginalTranBox",.ShowOriginalTran
				DlgValue "ApplyCheckResultBox",.ApplyCheckResult
				DlgValue "SpaceForEnAndAsiaBox",.SpaceForEnAndAsia
			End With
			For i = 0 To UBound(DefaultProjectList)
				If DefaultProjectList(i) = ProjectList(j).Name Then
					DlgEnable "ChangButton",False
					DlgEnable "DelButton",False
					Exit For
				End If
			Next i
			If DlgEnable("DelButton") = True Then
				If UBound(CheckList) = 0 Then DlgEnable "DelButton",False
			End If
		Else
			DlgEnable "ChangButton",False
			DlgEnable "DelButton",False
		End If
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		ProjectsFunc = True 'ֹ°ťرնԻ򴰿
		If getMsgList(UIDataList,MsgList,"SettingsDlgFunc",1) = False Then Exit Function
		Select Case DlgItem$
		Case "HelpButton"
			Call Help("ProjectHelp")
			Exit Function
		Case "OKButton"
			Temp = IIf(DlgValue("cWriteType") = 0,CheckFilePath,CheckRegKey)
			If WriteCheckSet(Temp,"Project") = False Then
				MsgBox Replace$(MsgList(17),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
			Else
				ProjectListBak = ProjectList
				ProjectsFunc = False
			End If
			Exit Function
		Case "CancelButton"
			ProjectList = ProjectListBak
			ProjectsFunc = False
			Exit Function
		Case "NextSetType"
			j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			If j < UBound(ProjectList) Then j = j + 1 Else j = 0
			DlgValue "ProjectList",j
			DlgItem$ = "ProjectList"
		Case "AddButton"
			TempList = getSetNameList(ProjectList)
			Temp = AddSet(TempList)
			If Temp = "" Then Exit Function
			j = 0
			If CheckArray(TempList) = True Then
				j = UBound(ProjectList) + 1
			End If
			ReDim Preserve TempList(j) As String,ProjectList(j) As CHECK_PROJECT_SET
			TempList(j) = Temp
			ProjectList(j).Name = Temp
			DlgListBoxArray "ProjectList",TempList()
			DlgValue "ProjectList",j
			DlgItem$ = "ProjectList"
		Case "ChangButton"
			j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			TempList = getSetNameList(ProjectList)
			Temp = EditSet(TempList,j)
			If Temp = "" Then Exit Function
			TempList(j) = Temp
			ProjectList(j).Name = Temp
			DlgListBoxArray "ProjectList",TempList()
			DlgValue "ProjectList",j
			Exit Function
    	Case "DelButton"
    		j = DlgValue("ProjectList")
    		If j < 0 Then Exit Function
			If MsgBox(Replace(MsgList(12),"%s",DlgText("ProjectList")),vbYesNo+vbInformation,MsgList(11)) = vbNo Then
				Exit Function
			End If
			Call DelProjectArray(ProjectList,j)
			If j > 0 Then j = j - 1
			TempList = getSetNameList(ProjectList)
			DlgListBoxArray "ProjectList",TempList()
			DlgValue "ProjectList",j
			DlgItem$ = "ProjectList"
		Case "ResetButton"
			j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			ReDim TempList(1)
			For i = 0 To UBound(DefaultProjectList)
				If DefaultProjectList(i) = ProjectList(j).Name Then
					TempList(0) = MsgList(1)
					Exit For
				End If
			Next i
			TempList(1) = MsgList(2)
			For i = 0 To UBound(ProjectList)
				If i <> j Then
					ReDim Preserve TempList(i + 2) As String
					TempList(i + 2) = MsgList(3) & " - " & ProjectList(i).Name
				End If
			Next i
			i = ShowPopupMenu(TempList,vbPopupUseRightButton)
			Select Case i
			Case Is < 0
				Exit Function
			Case 0
				ProjectList(j) = DefaultCheckSet(DlgText("ProjectList"),True)
				ProjectList(j).Name = DlgText("ProjectList")
			Case 1
				For n = 0 To UBound(ProjectListBak)
					If ProjectListBak(n).Name = ProjectList(j).Name Then
						ProjectList(j) = ProjectListBak(n)
						Exit For
					End If
				Next n
			Case Else
				Temp = Mid(TempList(i),InStr(TempList(i),MsgList(3) & " - ") + Len(MsgList(3) & " - "))
				For n = 0 To UBound(ProjectList)
					If ProjectList(n).Name = Temp Then
						ProjectList(j) = ProjectList(n)
						ProjectList(j).Name = DlgText("ProjectList")
						Exit For
					End If
				Next n
			End Select
			DlgItem$ = "ProjectList"
	    Case "CleanButton"
	    	j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			With ProjectList(i)
		    	.PreSpaceInSource = 0
				.PreSpaceInTarget = 0
				.PreSpaceInBoth = 0
				.EndSpaceInSource = 0
				.EndSpaceInTarget = 0
				.EndSpaceInBoth = 0
				.AcckeyInSource = 0
				.AcckeyInTarget = 0
				.AcckeyInBoth = 0
				.EndStrInSource = 0
				.EndStrInTarget = 0
				.EndStrInBoth = 0
				.ShortcutInSource = 0
				.ShortcutInTarget = 0
				.ShortcutInBoth = 0
				.DelSpace = 0
				.EnableStrSplit = 0
				.TranEndStr = 0
				.UseAcckeyInShortcut = 0
				.ShowOriginalTran = 0
				.ApplyCheckResult = 0
				.SpaceForEnAndAsia = 0
			End With
			DlgItem$ = "ProjectList"
		Case "ImportButton"
			If PSL.SelectFile(Temp,True,MsgList(22),MsgList(20)) = False Then Exit Function
			Select Case GetCheckSet("Project",Temp)
			Case -1
				Exit Function
			Case 3
				TempList = getSetNameList(ProjectList)
				DlgListBoxArray "ProjectList",TempList()
				DlgValue "ProjectList",0
				MsgBox MsgList(16),vbOkOnly+vbInformation,MsgList(14)
				DlgItem$ = "ProjectList"
			Case Else
				MsgBox Replace$(MsgList(18),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End Select
		Case "ExportButton"
			j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			For i = 0 To UBound(CheckList)
				If CheckCheckSet(CheckList,i) = False Then
					If MsgBox(Replace$(MsgList(9),"%s",CheckList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
						Exit Function
					End If
				End If
			Next i
			If PSL.SelectFile(Temp,False,MsgList(22),MsgList(21)) = True Then
				If InStr(Temp,".dat") = 0 Then Temp = Temp & ".dat"
				If WriteCheckSet(Temp,"Sets",3) = False Then
					MsgBox Replace$(MsgList(19),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
				Else
					MsgBox MsgList(18),vbOkOnly+vbInformation,MsgList(14)
				End If
			End If
			Exit Function
		Case "TestButton"
			j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			For i = 0 To UBound(CheckList)
				If CheckCheckSet(CheckList,i) = False Then
					If MsgBox(Replace$(MsgList(9),"%s",CheckList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
						Exit Function
					End If
				End If
			Next i
			n = -1
			For i = 0 To UBound(CheckList)
				If CheckList(i).Name = cSelected(2) Then
					n = i
					Exit For
				End If
			Next i
			If n < 0 Then n = 0
			Call CheckTest(n,j)
			Exit Function
		End Select

		j = DlgValue("ProjectList")
		If j < 0 Then Exit Function
		With ProjectList(j)
			If DlgItem$ = "ProjectList" Then
				DlgValue "PreSpaceinSourceBox",.PreSpaceInSource
				DlgValue "PreSpaceinTargetBox",.PreSpaceInTarget
				DlgValue "PreSpaceinBothBox",.PreSpaceInBoth
				DlgValue "EndSpaceinSourceBox",.EndSpaceInSource
				DlgValue "EndSpaceinTargetBox",.EndSpaceInTarget
				DlgValue "EndSpaceinBothBox",.EndSpaceInBoth
				DlgValue "AcckeyinSourceBox",.AcckeyInSource
				DlgValue "AcckeyinTargetBox",.AcckeyInTarget
				DlgValue "AcckeyinBothBox",.AcckeyInBoth
				DlgValue "EndStringinSourceBox",.EndStrInSource
				DlgValue "EndStringinTargetBox",.EndStrInTarget
				DlgValue "EndStringinBothBox",.EndStrInBoth
				DlgValue "ShortcutinSourceBox",.ShortcutInSource
				DlgValue "ShortcutinTargetBox",.ShortcutInTarget
				DlgValue "ShortcutinBothBox",.ShortcutInBoth
				DlgValue "DelSpaceBox",.DelSpace
				DlgValue "EnableStringSplitBox",.EnableStrSplit
				DlgValue "TranEndStringBox",.TranEndStr
				DlgValue "AcckeyInShortcutBox",.UseAcckeyInShortcut
				DlgValue "ShowOriginalTranBox",.ShowOriginalTran
				DlgValue "ApplyCheckResultBox",.ApplyCheckResult
				DlgValue "SpaceForEnAndAsiaBox",.SpaceForEnAndAsia
			Else
				.PreSpaceInSource = DlgValue("PreSpaceinSourceBox")
				.PreSpaceInTarget = DlgValue("PreSpaceinTargetBox")
				.PreSpaceInBoth = DlgValue("PreSpaceinBothBox")
				.EndSpaceInSource = DlgValue("EndSpaceinSourceBox")
				.EndSpaceInTarget = DlgValue("EndSpaceinTargetBox")
				.EndSpaceInBoth = DlgValue("EndSpaceinBothBox")
				.AcckeyInSource = DlgValue("AcckeyinSourceBox")
				.AcckeyInTarget = DlgValue("AcckeyinTargetBox")
				.AcckeyInBoth = DlgValue("AcckeyinBothBox")
				.EndStrInSource = DlgValue("EndStringinSourceBox")
				.EndStrInTarget = DlgValue("EndStringinTargetBox")
				.EndStrInBoth = DlgValue("EndStringinBothBox")
				.ShortcutInSource = DlgValue("ShortcutinSourceBox")
				.ShortcutInTarget = DlgValue("ShortcutinTargetBox")
				.ShortcutInBoth = DlgValue("ShortcutinBothBox")
				.DelSpace = DlgValue("DelSpaceBox")
				.EnableStrSplit = DlgValue("EnableStringSplitBox")
				.TranEndStr = DlgValue("TranEndStringBox")
				.UseAcckeyInShortcut = DlgValue("AcckeyInShortcutBox")
				.ShowOriginalTran = DlgValue("ShowOriginalTranBox")
				.ApplyCheckResult = DlgValue("ApplyCheckResultBox")
				.SpaceForEnAndAsia = DlgValue("SpaceForEnAndAsiaBox")
			End If
			n = -1
			For i = 0 To UBound(DefaultProjectList)
				If DefaultProjectList(i) = .Name Then
					n = i
					Exit For
				End If
			Next i
			If n > -1 Then
				DlgEnable "ChangButton",False
				DlgEnable "DelButton",False
			Else
				DlgEnable "ChangButton",True
				DlgEnable "DelButton",IIf(UBound(ProjectList) = 0,False,True)
			End If
		End With
	End Select
End Function


'Զ
Function Settings(ByVal CheckID As Long,ByVal OptionID As Long) As Long
	Dim MsgList() As String,TempList() As String
	Settings = CheckID
	If getMsgList(UIDataList,MsgList,"Settings",1) = False Then Exit Function
	TempList = getSetNameList(CheckList)
	Begin Dialog UserDialog 660,518,MsgList(0),.SettingsDlgFunc ' %GRID:10,7,1,1
		TextBox 0,0,0,21,.SuppValueBox
		Text 20,7,620,28,MsgList(1),.MainText
		OptionGroup .Options
			OptionButton 110,42,170,14,MsgList(2),.StrHandle
			OptionButton 290,42,170,14,MsgList(3),.AutoUpdate
			OptionButton 470,42,170,14,MsgList(4),.UILangListSet

		GroupBox 20,70,360,77,MsgList(5),.GroupBox1
		DropListBox 40,91,290,21,TempList(),.CheckList
		PushButton 330,91,30,21,MsgList(6),.LevelButton
		PushButton 40,119,90,21,MsgList(7),.AddButton
		PushButton 155,119,90,21,MsgList(8),.ChangButton
		PushButton 270,119,90,21,MsgList(9),.DelButton

		GroupBox 390,70,250,77,MsgList(10),.GroupBox2
		OptionGroup .cWriteType
			OptionButton 410,94,100,14,MsgList(11),.cWriteToFile
			OptionButton 520,94,100,14,MsgList(12),.cWriteToRegistry
		PushButton 410,119,90,21,MsgList(13),.ImportButton
		PushButton 530,119,90,21,MsgList(14),.ExportButton

		GroupBox 20,189,620,287,MsgList(15),.GroupBox3
		Text 30,164,190,14,MsgList(16),.SetItemText,1
		DropListBox 240,161,250,21,TempList(),.SetType
		PushButton 490,161,30,21,MsgList(17),.NextSetType

		Text 40,210,580,14,MsgList(18),.AccKeyBoxTxt
		Text 40,259,580,14,MsgList(19),.ExCrBoxTxt
		Text 40,308,580,14,MsgList(20),.ChkBktBoxTxt
		Text 40,357,580,14,MsgList(21),.KpPairBoxTxt
		TextBox 40,231,580,21,.AccKeyBox
		TextBox 40,280,580,21,.ExCrBox,1
		TextBox 40,329,580,21,.ChkBktBox
		TextBox 40,378,580,42,.KpPairBox,1
		CheckBox 40,427,580,14,MsgList(22),.AsiaKeyBox
		CheckBox 40,448,580,14,MsgList(23),.AddAcckeyBox

		Text 40,210,580,14,MsgList(24),.ChkEndBoxTxt
		Text 40,294,580,14,MsgList(25),.NoTrnEndBoxTxt
		Text 40,378,580,14,MsgList(26),.AutoTrnEndBoxTxt
		TextBox 40,231,580,56,.ChkEndBox,1
		TextBox 40,315,580,56,.NoTrnEndBox,1
		TextBox 40,399,580,63,.AutoTrnEndBox,1

		Text 40,210,580,14,MsgList(27),.ShortBoxTxt
		Text 40,259,580,14,MsgList(28),.ShortKeyBoxTxt
		Text 40,371,580,14,MsgList(29),.KpShortKeyBoxTxt
		TextBox 40,231,580,21,.ShortBox
		TextBox 40,280,580,84,.ShortKeyBox,1
		TextBox 40,392,580,70,.KpShortKeyBox,1

		Text 40,210,580,14,MsgList(30),.PreRepStrBoxTxt
		Text 40,210,580,14,MsgList(31),.AutoWebFlagBoxTxt
		TextBox 40,231,580,98,.PreRepStrBox,1
		TextBox 40,231,580,231,.AutoWebFlagBox,1

		Text 40,210,580,77,MsgList(32),.LineSplitBoxTxt
		Text 40,294,580,14,MsgList(33),.PreInsertSplitBoxTxt
		Text 40,343,580,14,MsgList(34),.AppInsertSplitBoxTxt
		Text 40,392,580,14,MsgList(35),.ReplaceSplitBoxTxt
		TextBox 40,315,580,21,.PreInsertSplitBox
		TextBox 40,364,580,21,.AppInsertSplitBox
		TextBox 40,413,580,21,.ReplaceSplitBox
		CheckBox 40,448,580,14,MsgList(36),.LineSplitModeBox

		Text 40,203,200,14,MsgList(37),.AppLngText
		Text 420,203,200,14,MsgList(38),.UseLngText
		ListBox 40,217,200,245,TempList(),.AppLngList
		ListBox 420,217,200,245,TempList(),.UseLngList
		PushButton 260,217,140,21,MsgList(39),.AddLangButton
		PushButton 260,238,140,21,MsgList(40),.AddAllLangButton
		PushButton 260,266,140,21,MsgList(41),.DelLangButton
		PushButton 260,287,140,21,MsgList(42),.DelAllLangButton
		PushButton 260,322,140,21,MsgList(43),.SetAppLangButton
		PushButton 260,343,140,21,MsgList(44),.EditAppLangButton
		PushButton 260,364,140,21,MsgList(45),.DelAppLangButton
		PushButton 260,399,140,21,MsgList(46),.SetUseLangButton
		PushButton 260,420,140,21,MsgList(47),.EditUseLangButton
		PushButton 260,441,140,21,MsgList(48),.DelUseLangButton

		GroupBox 20,70,620,91,MsgList(49),.UpdateSetGroup
		OptionGroup .UpdateSet
			OptionButton 40,91,580,14,MsgList(50),.AutoButton
			OptionButton 40,112,580,14,MsgList(51),.ManualButton
			OptionButton 40,133,580,14,MsgList(52),.OffButton
		GroupBox 20,175,620,49,MsgList(53),.CheckGroup
		Text 40,196,100,14,MsgList(54),.UpdateCycleText
		TextBox 150,192,40,21,.UpdateCycleBox
		Text 200,196,60,14,MsgList(55),.UpdateDatesText
		Text 280,196,130,14,MsgList(56),.UpdateDateText
		TextBox 420,192,100,21,.UpdateDateBox
		PushButton 540,192,80,21,MsgList(57),.CheckButton
		GroupBox 20,238,620,98,MsgList(58),.WebSiteGroup
		TextBox 40,259,580,63,.WebSiteBox,1
		GroupBox 20,350,620,126,MsgList(59),.CmdGroup
		Text 40,371,550,14,MsgList(60),.CmdPathBoxText
		Text 40,420,550,14,MsgList(61),.ArgumentBoxText
		TextBox 40,392,550,21,.CmdPathBox
		TextBox 40,441,550,21,.ArgumentBox
		PushButton 590,392,30,21,MsgList(6),.ExeBrowseButton
		PushButton 590,441,30,21,MsgList(62),.ArgumentButton

		GroupBox 20,70,620,280,MsgList(63),.UILangSetGroup
		Text 40,91,580,147,MsgList(64),.UILangSetText1
		Text 40,255,130,14,MsgList(65),.UILangSetText2
		DropListBox 180,252,360,21,TempList(),.UILangList
		Text 40,294,580,42,MsgList(66),.UILangSetText3

		GroupBox 20,364,620,112,MsgList(67),.UIFontSetGroup
		Text 40,388,130,14,MsgList(68),.MainFontText
		TextBox 180,385,360,21,.MainFontBox
		PushButton 540,385,30,21,MsgList(69),.MainFontButton

		PushButton 20,490,90,21,MsgList(70),.HelpButton
		PushButton 120,490,100,21,MsgList(71),.ResetButton
		PushButton 330,490,90,21,MsgList(72),.TestButton
		PushButton 230,490,90,21,MsgList(73),.CleanButton
		PushButton 120,490,160,21,MsgList(74),.EditUILangButton
		OKButton 460,490,90,21,.OKButton
		CancelButton 560,490,80,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.CheckList = CheckID
	dlg.Options = OptionID
	If Dialog(dlg) = 0 Then Exit Function
	Settings = dlg.CheckList
End Function


'ز鿴Ի˽Ϣ
Private Function SettingsDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,n As Long,HeaderID As Long,LangPair As LANG_SET
	Dim Temp As String,TempList() As String,MsgList() As String,Dic As Object
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		If getMsgList(UIDataList,MsgList,"SettingsDlgFunc",1) = False Then Exit Function
		DlgText "SuppValueBox",CStr$(SuppValue)
		DlgVisible "SuppValueBox",False
		DlgEnable "MainFontBox",False

		TempList = ReSplit(MsgList(32),";")
		DlgListBoxArray "SetType",TempList()
		DlgValue "SetType",0

		ReDim TempList(UBound(UIFileList) + 2) As String
		n = 1
		For i = 0 To UBound(UIFileList) + 2
			If i = 0 Then
				TempList(i) = MsgList(33)
			ElseIf i = 1 Then
				TempList(i) = MsgList(34)
			ElseIf UIFileList(i - 2).FilePath <> "" Then
				TempList(i) = UIFileList(i - 2).LangName
				n = n + 1
				If cSelected(0) = UIFileList(i - 2).LangID Then j = i
			End If
		Next i
		ReDim Preserve TempList(n) As String
		DlgListBoxArray "UILangList",TempList()
		DlgValue "UILangList",IIf(j < 2,StrToLong(cSelected(0),0),j)
		DlgText "MainFontBox",GetFontText(SuppValue,LFList(0))

		Select Case cWriteLoc
		Case CheckFilePath
			DlgValue "cWriteType",0
		Case CheckRegKey
			DlgValue "cWriteType",1
		Case Else
			DlgValue "cWriteType",0
		End Select

		j = DlgValue("CheckList")
		If j < 0 Then
			DlgValue "CheckList",0
			j = 0
		End If
		If CheckCheckSet(CheckList,j) = True Then
			With CheckList(j)
				DlgText "ExCrBox",.AccKeyExcludeChar
				DlgText "PreInsertSplitBox",.PreInsertSplitChar
				DlgText "ChkBktBox",.CheckBracket
				DlgText "KpPairBox",.KeepCharPair
				DlgValue "AsiaKeyBox",.ShowAsiaKey
				DlgText "ChkEndBox",.CheckEndChar
				DlgText "NoTrnEndBox",.NotTrnEndChar
				DlgText "AutoTrnEndBox",.AutoTrnEndChar
				DlgText "ShortBox",.CheckShortChar
				DlgText "ShortKeyBox",.CheckShortKey
				DlgText "KpShortKeyBox",.KeepShortKey
				DlgText "PreRepStrBox",.PreRepStr
				DlgText "AutoWebFlagBox",.AppRepStr
				DlgText "AccKeyBox",.AccKeyChar
				DlgValue "AddAcckeyBox",.AccKeyWithFirstChar
				DlgValue "LineSplitModeBox",.LineSplitMode
				DlgText "AppInsertSplitBox",.AppInsertSplitChar
				DlgText "ReplaceSplitBox",.ReplaceSplitChar
				TempList = GetLangSet(.LangPairList,9)
				DlgListBoxArray "AppLngList",TempList()
				TempList = GetLangSet(.LangPairList,10)
				DlgListBoxArray "UseLngList",TempList()
				DlgValue "AppLngList",0
				DlgValue "UseLngList",0
			End With
		End If
		DlgText "AppLngText",Replace$(MsgList(23),"%s",CStr$(DlgListBoxArray("AppLngList")))
		DlgText "UseLngText",Replace$(MsgList(24),"%s",CStr$(DlgListBoxArray("UseLngList")))

		If CheckArray(UpdateSet) = True Then
			DlgValue "UpdateSet",StrToLong(UpdateSet(0))
			DlgText "WebSiteBox",UpdateSet(1)
			DlgText "CmdPathBox",UpdateSet(2)
			DlgText "ArgumentBox",UpdateSet(3)
			DlgText "UpdateCycleBox",UpdateSet(4)
			DlgText "UpdateDateBox",UpdateSet(5)
		End If
		If DlgText("UpdateDateBox") = "" Then DlgText "UpdateDateBox",MsgList(4)
		DlgEnable "UpdateDateBox",False

		Select Case DlgValue("Options")
		Case 0
			j = -1
			n = DlgValue("CheckList")
			If n > -1 Then
				For i = 0 To UBound(DefaultCheckList)
					If DefaultCheckList(i) = CheckList(n).Name Then
						j = i
						Exit For
					End If
				Next i
			End If
			If j > -1 Then
				DlgEnable "ChangButton",False
				DlgEnable "DelButton",False
			Else
				If UBound(CheckList) = 0 Then DlgEnable "DelButton",False
			End If
			If DlgListBoxArray("AppLngList") = 0 Then
				DlgEnable "AddLangButton",False
				DlgEnable "AddAllLangButton",False
				DlgEnable "EditAppLangButton",False
				DlgEnable "DelAppLangButton",False
			End If
			If DlgListBoxArray("UseLngList") = 0 Then
				DlgEnable "DelLangButton",False
				DlgEnable "DelAllLangButton",False
				DlgEnable "EditUseLangButton",False
				DlgEnable "DelUseLangButton",False
			End If
			If DlgValue("AsiaKeyBox") = 1 Then
				DlgEnable "AddAcckeyBox",False
				DlgValue "AddAcckeyBox",0
			End If
		End Select

		DlgVisible "PreRepStrBoxTxt",False
		DlgVisible "PreRepStrBox",False
		If DlgValue("Options") < 2 Then
			DlgVisible "EditUILangButton",False
		Else
			DlgVisible "ResetButton",False
			DlgVisible "TestButton",False
			DlgVisible "CleanButton",False
		End If
		If DlgValue("Options") <> 0 Then
			DlgVisible "GroupBox1",False
			DlgVisible "CheckList",False
			DlgVisible "LevelButton",False
			DlgVisible "AddButton",False
			DlgVisible "ChangButton",False
			DlgVisible "DelButton",False

			DlgVisible "GroupBox2",False
			DlgVisible "cWriteType",False
			DlgVisible "ImportButton",False
			DlgVisible "ExportButton",False

			DlgVisible "GroupBox3",False
			DlgVisible "SetType",False
			DlgVisible "NextSetType",False
			DlgVisible "SetItemText",False

			DlgVisible "AccKeyBoxTxt",False
			DlgVisible "ExCrBoxTxt",False
			DlgVisible "ChkBktBoxTxt",False
			DlgVisible "KpPairBoxTxt",False
			DlgVisible "AccKeyBox",False
			DlgVisible "ExCrBox",False
			DlgVisible "ChkBktBox",False
			DlgVisible "KpPairBox",False
			DlgVisible "AsiaKeyBox",False
			DlgVisible "AddAcckeyBox",False

			DlgVisible "ChkEndBoxTxt",False
			DlgVisible "NoTrnEndBoxTxt",False
			DlgVisible "AutoTrnEndBoxTxt",False
			DlgVisible "ChkEndBox",False
			DlgVisible "NoTrnEndBox",False
			DlgVisible "AutoTrnEndBox",False

			DlgVisible "ShortBoxTxt",False
			DlgVisible "ShortKeyBoxTxt",False
			DlgVisible "KpShortKeyBoxTxt",False
			DlgVisible "ShortBox",False
			DlgVisible "ShortKeyBox",False
			DlgVisible "KpShortKeyBox",False

			DlgVisible "PreRepStrBoxTxt",False
			DlgVisible "AutoWebFlagBoxTxt",False
			DlgVisible "PreRepStrBox",False
			DlgVisible "AutoWebFlagBox",False

			DlgVisible "LineSplitBoxTxt",False
			DlgVisible "PreInsertSplitBoxTxt",False
			DlgVisible "AppInsertSplitBoxTxt",False
			DlgVisible "ReplaceSplitBoxTxt",False
			DlgVisible "PreInsertSplitBox",False
			DlgVisible "AppInsertSplitBox",False
			DlgVisible "ReplaceSplitBox",False
			DlgVisible "LineSplitModeBox",False

			DlgVisible "AppLngText",False
			DlgVisible "UseLngText",False
			DlgVisible "AppLngList",False
			DlgVisible "UseLngList",False
			DlgVisible "AddLangButton",False
			DlgVisible "AddAllLangButton",False
			DlgVisible "DelLangButton",False
			DlgVisible "DelAllLangButton",False
			DlgVisible "SetAppLangButton",False
			DlgVisible "EditAppLangButton",False
			DlgVisible "DelAppLangButton",False
			DlgVisible "SetUseLangButton",False
			DlgVisible "EditUseLangButton",False
			DlgVisible "DelUseLangButton",False
		Else
			If DlgValue("SetType") <> 0 Then
				DlgVisible "AccKeyBoxTxt",False
				DlgVisible "ExCrBoxTxt",False
				DlgVisible "ChkBktBoxTxt",False
				DlgVisible "KpPairBoxTxt",False
				DlgVisible "AccKeyBox",False
				DlgVisible "ExCrBox",False
				DlgVisible "ChkBktBox",False
				DlgVisible "KpPairBox",False
				DlgVisible "AsiaKeyBox",False
				DlgVisible "AddAcckeyBox",False
			End If
			If DlgValue("SetType") <> 1 Then
				DlgVisible "ChkEndBoxTxt",False
				DlgVisible "NoTrnEndBoxTxt",False
				DlgVisible "AutoTrnEndBoxTxt",False
				DlgVisible "ChkEndBox",False
				DlgVisible "NoTrnEndBox",False
				DlgVisible "AutoTrnEndBox",False
			End If
			If DlgValue("SetType") <> 2 Then
				DlgVisible "ShortBoxTxt",False
				DlgVisible "ShortKeyBoxTxt",False
				DlgVisible "KpShortKeyBoxTxt",False
				DlgVisible "ShortBox",False
				DlgVisible "ShortKeyBox",False
				DlgVisible "KpShortKeyBox",False
			End If
			If DlgValue("SetType") <> 3 Then
				DlgVisible "AutoWebFlagBoxTxt",False
				DlgVisible "AutoWebFlagBox",False
			End If
			If DlgValue("SetType") <> 4 Then
				DlgVisible "LineSplitBoxTxt",False
				DlgVisible "PreInsertSplitBoxTxt",False
				DlgVisible "AppInsertSplitBoxTxt",False
				DlgVisible "ReplaceSplitBoxTxt",False
				DlgVisible "PreInsertSplitBox",False
				DlgVisible "AppInsertSplitBox",False
				DlgVisible "ReplaceSplitBox",False
				DlgVisible "LineSplitModeBox",False
			End If
			If DlgValue("SetType") <> 5 Then
				DlgVisible "AppLngText",False
				DlgVisible "UseLngText",False
				DlgVisible "AppLngList",False
				DlgVisible "UseLngList",False
				DlgVisible "AddLangButton",False
				DlgVisible "AddAllLangButton",False
				DlgVisible "DelLangButton",False
				DlgVisible "DelAllLangButton",False
				DlgVisible "SetAppLangButton",False
				DlgVisible "EditAppLangButton",False
				DlgVisible "DelAppLangButton",False
				DlgVisible "SetUseLangButton",False
				DlgVisible "EditUseLangButton",False
				DlgVisible "DelUseLangButton",False
			End If
		End If
		If DlgValue("Options") <> 1 Then
			DlgVisible "UpdateSetGroup",False
			DlgVisible "UpdateSet",False
			DlgVisible "AutoButton",False
			DlgVisible "ManualButton",False
			DlgVisible "OffButton",False
			DlgVisible "CheckGroup",False
			DlgVisible "UpdateCycleText",False
			DlgVisible "UpdateCycleBox",False
			DlgVisible "UpdateDatesText",False
			DlgVisible "UpdateDateText",False
			DlgVisible "UpdateDateBox",False
			DlgVisible "CheckButton",False
			DlgVisible "WebSiteGroup",False
			DlgVisible "WebSiteBox",False
			DlgVisible "CmdGroup",False
			DlgVisible "CmdPathBoxText",False
			DlgVisible "ArgumentBoxText",False
			DlgVisible "CmdPathBox",False
			DlgVisible "ArgumentBox",False
			DlgVisible "ExeBrowseButton",False
			DlgVisible "ArgumentButton",False
		End If
		If DlgValue("Options") <> 2 Then
			DlgVisible "UILangSetGroup",False
			DlgVisible "UILangSetText1",False
			DlgVisible "UILangSetText2",False
			DlgVisible "UILangList",False
			DlgVisible "UILangSetText3",False

			DlgVisible "UIFontSetGroup",False
			DlgVisible "MainFontText",False
			DlgVisible "MainFontBox",False
			DlgVisible "MainFontButton",False
		End If

		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		SettingsDlgFunc = True 'ֹ°ťرնԻ򴰿
		If getMsgList(UIDataList,MsgList,"SettingsDlgFunc",1) = False Then Exit Function
		If DlgItem$ = "NextSetType" Then
			i = DlgValue("SetType")
			If i < 5 Then i = i + 1 Else i = 0
			DlgValue "SetType",i
		End If
		Select Case DlgItem$
		Case "Options","SetType","NextSetType"
			If DlgValue("Options") = 0 Then
				DlgVisible "GroupBox1",True
				DlgVisible "CheckList",True
				DlgVisible "LevelButton",True
				DlgVisible "AddButton",True
				DlgVisible "ChangButton",True
				DlgVisible "DelButton",True

				DlgVisible "GroupBox2",True
				DlgVisible "cWriteType",True
				DlgVisible "ImportButton",True
				DlgVisible "ExportButton",True

				DlgVisible "GroupBox3",True
				DlgVisible "SetType",True
				DlgVisible "NextSetType",True
				DlgVisible "SetItemText",True
				If DlgValue("SetType") = 0 Then
					DlgVisible "AccKeyBoxTxt",True
					DlgVisible "ExCrBoxTxt",True
					DlgVisible "ChkBktBoxTxt",True
					DlgVisible "KpPairBoxTxt",True
					DlgVisible "AccKeyBox",True
					DlgVisible "ExCrBox",True
					DlgVisible "ChkBktBox",True
					DlgVisible "KpPairBox",True
					DlgVisible "AsiaKeyBox",True
					DlgVisible "AddAcckeyBox",True
				Else
					DlgVisible "AccKeyBoxTxt",False
					DlgVisible "ExCrBoxTxt",False
					DlgVisible "ChkBktBoxTxt",False
					DlgVisible "KpPairBoxTxt",False
					DlgVisible "AccKeyBox",False
					DlgVisible "ExCrBox",False
					DlgVisible "ChkBktBox",False
					DlgVisible "KpPairBox",False
					DlgVisible "AsiaKeyBox",False
					DlgVisible "AddAcckeyBox",False
				End If
				If DlgValue("SetType") = 1 Then
					DlgVisible "ChkEndBoxTxt",True
					DlgVisible "NoTrnEndBoxTxt",True
					DlgVisible "AutoTrnEndBoxTxt",True
					DlgVisible "ChkEndBox",True
					DlgVisible "NoTrnEndBox",True
					DlgVisible "AutoTrnEndBox",True
				Else
					DlgVisible "ChkEndBoxTxt",False
					DlgVisible "NoTrnEndBoxTxt",False
					DlgVisible "AutoTrnEndBoxTxt",False
					DlgVisible "ChkEndBox",False
					DlgVisible "NoTrnEndBox",False
					DlgVisible "AutoTrnEndBox",False
				End If
				If DlgValue("SetType") = 2 Then
					DlgVisible "ShortBoxTxt",True
					DlgVisible "ShortKeyBoxTxt",True
					DlgVisible "KpShortKeyBoxTxt",True
					DlgVisible "ShortBox",True
					DlgVisible "ShortKeyBox",True
					DlgVisible "KpShortKeyBox",True
				Else
					DlgVisible "ShortBoxTxt",False
					DlgVisible "ShortKeyBoxTxt",False
					DlgVisible "KpShortKeyBoxTxt",False
					DlgVisible "ShortBox",False
					DlgVisible "ShortKeyBox",False
					DlgVisible "KpShortKeyBox",False
				End If
				If DlgValue("SetType") = 3 Then
					DlgVisible "PreRepStrBoxTxt",False
					DlgVisible "AutoWebFlagBoxTxt",True
					DlgVisible "PreRepStrBox",False
					DlgVisible "AutoWebFlagBox",True
				Else
					DlgVisible "PreRepStrBoxTxt",False
					DlgVisible "AutoWebFlagBoxTxt",False
					DlgVisible "PreRepStrBox",False
					DlgVisible "AutoWebFlagBox",False
				End If
				If DlgValue("SetType") = 4 Then
					DlgVisible "LineSplitBoxTxt",True
					DlgVisible "PreInsertSplitBoxTxt",True
					DlgVisible "AppInsertSplitBoxTxt",True
					DlgVisible "ReplaceSplitBoxTxt",True
					DlgVisible "PreInsertSplitBox",True
					DlgVisible "AppInsertSplitBox",True
					DlgVisible "ReplaceSplitBox",True
					DlgVisible "LineSplitModeBox",True
				Else
					DlgVisible "LineSplitBoxTxt",False
					DlgVisible "PreInsertSplitBoxTxt",False
					DlgVisible "AppInsertSplitBoxTxt",False
					DlgVisible "ReplaceSplitBoxTxt",False
					DlgVisible "PreInsertSplitBox",False
					DlgVisible "AppInsertSplitBox",False
					DlgVisible "ReplaceSplitBox",False
					DlgVisible "LineSplitModeBox",False
				End If
				If DlgValue("SetType") = 5 Then
					DlgVisible "AppLngText",True
					DlgVisible "UseLngText",True
					DlgVisible "AppLngList",True
					DlgVisible "UseLngList",True
					DlgVisible "AddLangButton",True
					DlgVisible "AddAllLangButton",True
					DlgVisible "DelLangButton",True
					DlgVisible "DelAllLangButton",True
					DlgVisible "SetAppLangButton",True
					DlgVisible "EditAppLangButton",True
					DlgVisible "DelAppLangButton",True
					DlgVisible "SetUseLangButton",True
					DlgVisible "EditUseLangButton",True
					DlgVisible "DelUseLangButton",True
				Else
					DlgVisible "AppLngText",False
					DlgVisible "UseLngText",False
					DlgVisible "AppLngList",False
					DlgVisible "UseLngList",False
					DlgVisible "AddLangButton",False
					DlgVisible "AddAllLangButton",False
					DlgVisible "DelLangButton",False
					DlgVisible "DelAllLangButton",False
					DlgVisible "SetAppLangButton",False
					DlgVisible "EditAppLangButton",False
					DlgVisible "DelAppLangButton",False
					DlgVisible "SetUseLangButton",False
					DlgVisible "EditUseLangButton",False
					DlgVisible "DelUseLangButton",False
				End If
			Else
				DlgVisible "GroupBox1",False
				DlgVisible "CheckList",False
				DlgVisible "LevelButton",False
				DlgVisible "AddButton",False
				DlgVisible "ChangButton",False
				DlgVisible "DelButton",False

				DlgVisible "GroupBox2",False
				DlgVisible "cWriteType",False
				DlgVisible "ImportButton",False
				DlgVisible "ExportButton",False

				DlgVisible "GroupBox3",False
				DlgVisible "SetType",False
				DlgVisible "NextSetType",False
				DlgVisible "SetItemText",False

				DlgVisible "AccKeyBoxTxt",False
				DlgVisible "ExCrBoxTxt",False
				DlgVisible "ChkBktBoxTxt",False
				DlgVisible "KpPairBoxTxt",False
				DlgVisible "AccKeyBox",False
				DlgVisible "ExCrBox",False
				DlgVisible "ChkBktBox",False
				DlgVisible "KpPairBox",False
				DlgVisible "AsiaKeyBox",False
				DlgVisible "AddAcckeyBox",False

				DlgVisible "ChkEndBoxTxt",False
				DlgVisible "NoTrnEndBoxTxt",False
				DlgVisible "AutoTrnEndBoxTxt",False
				DlgVisible "ChkEndBox",False
				DlgVisible "NoTrnEndBox",False
				DlgVisible "AutoTrnEndBox",False

				DlgVisible "ShortBoxTxt",False
				DlgVisible "ShortKeyBoxTxt",False
				DlgVisible "KpShortKeyBoxTxt",False
				DlgVisible "ShortBox",False
				DlgVisible "ShortKeyBox",False
				DlgVisible "KpShortKeyBox",False

				DlgVisible "PreRepStrBoxTxt",False
				DlgVisible "AutoWebFlagBoxTxt",False
				DlgVisible "PreRepStrBox",False
				DlgVisible "AutoWebFlagBox",False

				DlgVisible "LineSplitBoxTxt",False
				DlgVisible "PreInsertSplitBoxTxt",False
				DlgVisible "AppInsertSplitBoxTxt",False
				DlgVisible "ReplaceSplitBoxTxt",False
				DlgVisible "PreInsertSplitBox",False
				DlgVisible "AppInsertSplitBox",False
				DlgVisible "ReplaceSplitBox",False
				DlgVisible "LineSplitModeBox",False

				DlgVisible "AppLngText",False
				DlgVisible "UseLngText",False
				DlgVisible "AppLngList",False
				DlgVisible "UseLngList",False
				DlgVisible "AddLangButton",False
				DlgVisible "AddAllLangButton",False
				DlgVisible "DelLangButton",False
				DlgVisible "DelAllLangButton",False
				DlgVisible "SetAppLangButton",False
				DlgVisible "EditAppLangButton",False
				DlgVisible "DelAppLangButton",False
				DlgVisible "SetUseLangButton",False
				DlgVisible "EditUseLangButton",False
				DlgVisible "DelUseLangButton",False
			End If
			If DlgValue("Options") = 1 Then
				DlgVisible "UpdateSetGroup",True
				DlgVisible "UpdateSet",True
				DlgVisible "AutoButton",True
				DlgVisible "ManualButton",True
				DlgVisible "OffButton",True
				DlgVisible "CheckGroup",True
				DlgVisible "UpdateCycleText",True
				DlgVisible "UpdateCycleBox",True
				DlgVisible "UpdateDatesText",True
				DlgVisible "UpdateDateText",True
				DlgVisible "UpdateDateBox",True
				DlgVisible "CheckButton",True
				DlgVisible "WebSiteGroup",True
				DlgVisible "WebSiteBox",True
				DlgVisible "CmdGroup",True
				DlgVisible "CmdPathBoxText",True
				DlgVisible "ArgumentBoxText",True
				DlgVisible "CmdPathBox",True
				DlgVisible "ArgumentBox",True
				DlgVisible "ExeBrowseButton",True
				DlgVisible "ArgumentButton",True
			Else
				DlgVisible "UpdateSetGroup",False
				DlgVisible "UpdateSet",False
				DlgVisible "AutoButton",False
				DlgVisible "ManualButton",False
				DlgVisible "OffButton",False
				DlgVisible "CheckGroup",False
				DlgVisible "UpdateCycleText",False
				DlgVisible "UpdateCycleBox",False
				DlgVisible "UpdateDatesText",False
				DlgVisible "UpdateDateText",False
				DlgVisible "UpdateDateBox",False
				DlgVisible "CheckButton",False
				DlgVisible "WebSiteGroup",False
				DlgVisible "WebSiteBox",False
				DlgVisible "CmdGroup",False
				DlgVisible "CmdPathBoxText",False
				DlgVisible "ArgumentBoxText",False
				DlgVisible "CmdPathBox",False
				DlgVisible "ArgumentBox",False
				DlgVisible "ExeBrowseButton",False
				DlgVisible "ArgumentButton",False
			End If
			If DlgValue("Options") = 2 Then
				DlgVisible "UILangSetGroup",True
				DlgVisible "UILangSetText1",True
				DlgVisible "UILangSetText2",True
				DlgVisible "UILangList",True
				DlgVisible "UILangSetText3",True

				DlgVisible "UIFontSetGroup",True
				DlgVisible "MainFontText",True
				DlgVisible "MainFontBox",True
				DlgVisible "MainFontButton",True

				DlgVisible "ResetButton",False
				DlgVisible "TestButton",False
				DlgVisible "CleanButton",False
				DlgVisible "EditUILangButton",True
			Else
				DlgVisible "UILangSetGroup",False
				DlgVisible "UILangSetText1",False
				DlgVisible "UILangSetText2",False
				DlgVisible "UILangList",False
				DlgVisible "UILangSetText3",False

				DlgVisible "UIFontSetGroup",False
				DlgVisible "MainFontText",False
				DlgVisible "MainFontBox",False
				DlgVisible "MainFontButton",False

				DlgVisible "ResetButton",True
				DlgVisible "TestButton",True
				DlgVisible "CleanButton",True
				DlgVisible "EditUILangButton",False
			End If
		Case "HelpButton"
			Select Case DlgValue("Options")
			Case 0
				Call Help("CheckSetHelp")
			Case 1
				Call Help("UpdateSetHelp")
			Case 2
				Call Help("UILangSetHelp")
			End Select
			Exit Function
		Case "OKButton"
			'Զ
			If DlgText("CmdPathBox") = "" Or DlgText("ArgumentBox") = "" Then
	    		MsgBox(MsgList(27),vbOkOnly+vbInformation,MsgList(0))
				Exit Function
			ElseIf Dir$(DlgText("CmdPathBox")) = "" Then
				MsgBox MsgList(9),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
	    	End If
	    	'鷭
	    	For i = 0 To UBound(CheckList)
	    		If CheckCheckSet(CheckList,i) = False Then
	    			If MsgBox(Replace$(MsgList(10),"%s",CheckList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
	    				Exit Function
					End If
				End If
			Next i
			If DlgValue("cWriteType") = 0 Then Temp = CheckFilePath Else Temp = CheckRegKey
			If WriteCheckSet(Temp,"Sets") = False Then
				MsgBox Replace$(MsgList(17),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End If
			CheckListBak = CheckList
			UpdateSetBak = UpdateSet
			LFListBak = LFList
			SettingsDlgFunc = False
			Exit Function
		Case "CancelButton"
			CheckList = CheckListBak
			UpdateSet = UpdateSetBak
			SettingsDlgFunc = False
			Exit Function
		End Select

		Select Case DlgValue("Options")
		Case 0
			Select Case DlgItem$
			Case "LevelButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				TempList = getSetNameList(CheckList)
				If SetLevel(TempList,j,MsgList(31)) = False Then Exit Function
				Temp = DlgText("CheckList")
				DlgListBoxArray "CheckList",TempList()
				DlgText "CheckList",Temp
				Set Dic = CreateObject("Scripting.Dictionary")
				For i = 0 To UBound(CheckList)
					If Not Dic.Exists(CheckList(i).Name) Then
						Dic.Add(CheckList(i).Name,i)
					End If
				Next i
				ReDim TempCheck(0) As CHECK_SET
				TempCheck = CheckList
				For i = 0 To UBound(TempList)
					If Dic.Exists(TempList(i)) Then
						TempCheck(n) = CheckList(Dic.Item(TempList(i)))
						n = n + 1
					End If
				Next i
				CheckList = TempCheck
				Set Dic = Nothing
				Exit Function
			Case "AddButton"
				TempList = getSetNameList(CheckList)
				Temp = AddSet(TempList)
				If Temp = "" Then Exit Function
				j = 0
				If CheckArray(TempList) = True Then
					j = UBound(CheckList) + 1
				End If
				ReDim Preserve TempList(j) As String,CheckList(j) As CHECK_SET
				CheckList(j).LangPairList = LangCodeList(Temp,1,-1)
				TempList(j) = Temp
				CheckList(j).Name = Temp
				DlgListBoxArray "CheckList",TempList()
				DlgValue "CheckList",j
				DlgItem$ = "CheckList"
			Case "ChangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				TempList = getSetNameList(CheckList)
				Temp = EditSet(TempList,j)
				If Temp = "" Then Exit Function
				TempList(j) = Temp
				CheckList(j).Name = Temp
				DlgListBoxArray "CheckList",TempList()
				DlgValue "CheckList",j
				Exit Function
	    	Case "DelButton"
	    		j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				If MsgBox(Replace(MsgList(12),"%s",DlgText("CheckList")),vbYesNo+vbInformation,MsgList(11)) = vbNo Then
					Exit Function
				End If
				Call DelCheckArray(CheckList,j)
				TempList = getSetNameList(CheckList)
				If j = UBound(TempList) + 1 Then j = j - 1
				DlgListBoxArray "CheckList",TempList()
				DlgValue "CheckList",j
				DlgItem$ = "CheckList"
			Case "ResetButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				ReDim TempList(1)
				For i = 0 To UBound(DefaultCheckList)
					If DefaultCheckList(i) = DlgText("CheckList") Then
						TempList(0) = MsgList(1)
						Exit For
					End If
				Next i
				TempList(1) = MsgList(2)
				For i = 0 To UBound(CheckList)
					If i <> j Then
						ReDim Preserve TempList(i + 2) As String
						TempList(i + 2) = MsgList(3) & " - " & CheckList(i).Name
					End If
				Next i
				i = ShowPopupMenu(TempList,vbPopupUseRightButton)
				Select Case i
				Case Is < 0
					Exit Function
				Case 0
					CheckList(j) = DefaultCheckSet(DlgText("CheckList"),False)
					CheckList(j).Name = DlgText("CheckList")
					CheckList(j).LangPairList = LangCodeList(DlgText("CheckList"),1,-1)
				Case 1
					For n = 0 To UBound(CheckListBak)
						If CheckListBak(n).Name = DlgText("CheckList") Then
							CheckList(j) = CheckListBak(n)
							Exit For
						End If
					Next n
				Case Else
					Temp = Mid(TempList(i),InStr(TempList(i),MsgList(3) & " - ") + Len(MsgList(3) & " - "))
					For n = 0 To UBound(CheckList)
						If CheckList(n).Name = Temp Then
							CheckList(j) = CheckList(n)
							CheckList(j).Name = DlgText("CheckList")
							Exit For
						End If
					Next n
				End Select
				DlgItem$ = "CheckList"
	    	Case "CleanButton"
	    		j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					Select Case DlgValue("SetType")
	    			Case 0
	    				.AccKeyChar = ""
						.AccKeyExcludeChar = ""
						.CheckBracket = ""
						.KeepCharPair = ""
						.ShowAsiaKey = 0
						.AccKeyWithFirstChar = 0
					Case 1
						.CheckEndChar = ""
						.NotTrnEndChar = ""
						.AutoTrnEndChar = ""
					Case 2
						.CheckShortChar = ""
						.CheckShortKey = ""
						.KeepShortKey = ""
					Case 3
						.PreRepStr = ""
						.AppRepStr = ""
					Case 4
						.LineSplitMode = 0
						.PreInsertSplitChar = ""
						.AppInsertSplitChar = ""
						.ReplaceSplitChar = ""
					Case 5
						For i = 0 To UBound(.LangPairList)
							.LangPairList(i).UseCode = ""
						Next i
					End Select
				End With
				DlgItem$ = "CheckList"
			Case "AddLangButton","DelLangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					If DlgItem$ = "AddLangButton" Then
						Temp = DlgText("AppLngList")
					Else
						Temp = DlgText("UseLngList")
					End If
					If Temp = "" Then Exit Function
					n = -1
					For i = 0 To UBound(.LangPairList)
						If .LangPairList(i).Name = Temp Then
							n = i
							Exit For
						End If
					Next i
					If n < 0 Then Exit Function
					Temp = .LangPairList(n).Name
					If DlgItem$ = "AddLangButton" Then
						.LangPairList(n).UseCode = .LangPairList(n).PslCode
						n = DlgValue("AppLngList")
					Else
						.LangPairList(n).UseCode = ""
						n = DlgValue("UseLngList")
					End If
					If n > 0 Then n = n - 1
					TempList = GetLangSet(.LangPairList,9)
					DlgListBoxArray "AppLngList",TempList()
					TempList = GetLangSet(.LangPairList,10)
					DlgListBoxArray "UseLngList",TempList()
					If DlgItem$ = "AddLangButton" Then
						DlgValue "AppLngList",n
						DlgText "UseLngList",Temp
					Else
						DlgText "AppLngList",Temp
						DlgValue "UseLngList",n
					End If
				End With
			Case "AddAllLangButton","DelAllLangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					If DlgItem$ = "AddAllLangButton" Then
						ReDim TempList(0) As String
						DlgListBoxArray "AppLngList",TempList()
						TempList = ChangeList(GetLangSet(.LangPairList,0),TempList)
						DlgListBoxArray "UseLngList",TempList()
						DlgValue "UseLngList",0
						For i = 0 To UBound(.LangPairList)
							.LangPairList(i).UseCode = .LangPairList(i).PslCode
						Next i
					Else
						ReDim TempList(0) As String
						DlgListBoxArray "UseLngList",TempList()
						TempList = ChangeList(GetLangSet(.LangPairList,0),TempList)
						DlgListBoxArray "AppLngList",TempList()
						DlgValue "AppLngList",0
						For i = 0 To UBound(.LangPairList)
							.LangPairList(i).UseCode = ""
						Next i
					End If
				End With
			Case "SetAppLangButton","SetUseLangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					LangPair = SetLang(.LangPairList,-1,IIf(DlgItem$ = "SetAppLangButton",False,True))
					If LangPair.Name = "" Or LangPair.PslCode = "" Then Exit Function
					If CheckArrEmpty(.LangPairList) = True Then
						n = UBound(.LangPairList) + 1
					End If
					ReDim Preserve CheckList(j).LangPairList(n) 'As LANG_SET
					.LangPairList(n) = LangPair
					If DlgItem$ = "SetAppLangButton" Then
						.LangPairList(n).UseCode = ""
						n = DlgListBoxArray("AppLngList")
						TempList = GetLangSet(.LangPairList,9)
						DlgListBoxArray "AppLngList",TempList()
						DlgValue "AppLngList",n
					Else
						.LangPairList(n).UseCode = .LangPairList(n).PslCode
						n = DlgListBoxArray("UseLngList")
						TempList = GetLangSet(.LangPairList,10)
						DlgListBoxArray "UseLngList",TempList()
						DlgValue "UseLngList",n
					End If
				End With
				Exit Function
			Case "EditAppLangButton","EditUseLangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					If DlgItem$ = "EditAppLangButton" Then
						Temp = DlgText("AppLngList")
					Else
						Temp = DlgText("UseLngList")
					End If
					If Temp = "" Then Exit Function
					n = -1
					For i = 0 To UBound(.LangPairList)
						If .LangPairList(i).Name = Temp Then
							n = i
							Exit For
						End If
					Next i
					If n < 0 Then Exit Function
					LangPair = SetLang(.LangPairList,n,IIf(DlgItem$ = "EditAppLangButton",False,True))
					If LangPair.Name = "" Or LangPair.PslCode = "" Then Exit Function
					.LangPairList(n) = LangPair
					If DlgItem$ = "EditAppLangButton" Then
						.LangPairList(n).UseCode = ""
						n = DlgValue("AppLngList")
						TempList = GetLangSet(.LangPairList,9)
						DlgListBoxArray "AppLngList",TempList()
						DlgValue "AppLngList",n
					Else
						.LangPairList(n).UseCode = .LangPairList(n).PslCode
						n = DlgValue("UseLngList")
						TempList = GetLangSet(.LangPairList,10)
						DlgListBoxArray "UseLngList",TempList()
						DlgValue "UseLngList",n
					End If
				End With
				Exit Function
			Case "DelAppLangButton","DelUseLangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					If DlgItem$ = "DelAppLangButton" Then
						Temp = DlgText("AppLngList")
					Else
						Temp = DlgText("UseLngList")
					End If
					If Temp = "" Then Exit Function
					If MsgBox(Replace(MsgList(13),"%s",Temp),vbYesNo+vbInformation,MsgList(11)) = vbNo Then Exit Function
					n = -1
					For i = 0 To UBound(.LangPairList)
						If .LangPairList(i).Name = Temp Then
							n = i
						End If
					Next i
					If n = -1 Then Exit Function
					Call DelLangPair(.LangPairList,n)
					If DlgItem$ = "DelAppLangButton" Then
						n = DlgValue("AppLngList")
						i = DlgListBoxArray("AppLngList")
						If n = i Then n = n - 1
						TempList = GetLangSet(.LangPairList,9)
						DlgListBoxArray "AppLngList",TempList()
						DlgValue "AppLngList",n
					Else
						n = DlgValue("UseLngList")
						i = DlgListBoxArray("UseLngList")
						If n = i Then n = n - 1
						TempList = GetLangSet(.LangPairList,10)
						DlgListBoxArray "UseLngList",TempList()
						DlgValue "UseLngList",n
					End If
				End With
			Case "ImportButton"
				If PSL.SelectFile(Temp,True,MsgList(22),MsgList(20)) = False Then Exit Function
				Select Case GetCheckSet("Sets",Temp)
				Case -1
					Exit Function
				Case 4
					TempList = getSetNameList(CheckList)
					DlgListBoxArray "CheckList",TempList()
					DlgValue "CheckList",UBound(CheckList)
					MsgBox MsgList(16),vbOkOnly+vbInformation,MsgList(14)
					DlgItem$ = "CheckList"
				Case Else
					MsgBox Replace$(MsgList(18),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
				End Select
			Case "ExportButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				For i = 0 To UBound(CheckList)
					If CheckCheckSet(CheckList,i) = False Then
						If MsgBox(Replace$(MsgList(10),"%s",CheckList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
							Exit Function
						End If
					End If
				Next i
				If PSL.SelectFile(Temp,False,MsgList(22),MsgList(21)) = True Then
					If InStr(Temp,".dat") = 0 Then Temp = Temp & ".dat"
					If WriteCheckSet(Temp,"Sets",3) = False Then
						MsgBox Replace$(MsgList(19),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
					Else
						MsgBox MsgList(15),vbOkOnly+vbInformation,MsgList(14)
					End If
				End If
				Exit Function
			Case "TestButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				For i = 0 To UBound(CheckList)
					If CheckCheckSet(CheckList,i) = False Then
						If MsgBox(Replace$(MsgList(10),"%s",CheckList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
							Exit Function
						End If
					End If
				Next i
				Call CheckTest(j,StrToLong(cSelected(5)))
				Exit Function
			End Select

			j = DlgValue("CheckList")
			If j < 0 Then Exit Function
			With CheckList(j)
				If DlgItem$ = "CheckList" Then
					DlgText "ExCrBox",.AccKeyExcludeChar
					DlgText "PreInsertSplitBox",.PreInsertSplitChar
					DlgText "ChkBktBox",.CheckBracket
					DlgText "KpPairBox",.KeepCharPair
					DlgValue "AsiaKeyBox",.ShowAsiaKey
					DlgText "ChkEndBox",.CheckEndChar
					DlgText "NoTrnEndBox",.NotTrnEndChar
					DlgText "AutoTrnEndBox",.AutoTrnEndChar
					DlgText "ShortBox",.CheckShortChar
					DlgText "ShortKeyBox",.CheckShortKey
					DlgText "KpShortKeyBox",.KeepShortKey
					DlgText "PreRepStrBox",.PreRepStr
					DlgText "AutoWebFlagBox",.AppRepStr
					DlgText "AccKeyBox",.AccKeyChar
					DlgValue "AddAcckeyBox",.AccKeyWithFirstChar
					DlgValue "LineSplitModeBox",.LineSplitMode
					DlgText "AppInsertSplitBox",.AppInsertSplitChar
					DlgText "ReplaceSplitBox",.ReplaceSplitChar
					TempList = GetLangSet(.LangPairList,9)
					DlgListBoxArray "AppLngList",TempList()
					TempList = GetLangSet(.LangPairList,10)
					DlgListBoxArray "UseLngList",TempList()
					DlgValue "AppLngList",0
					DlgValue "UseLngList",0
				ElseIf DlgValue("SetType") < 5 Then
					.ShowAsiaKey = DlgValue("AsiaKeyBox")
					.AccKeyWithFirstChar = DlgValue("AddAcckeyBox")
					.LineSplitMode = DlgValue("LineSplitModeBox")
				End If
				If DlgValue("SetType") = 5 Then
					If DlgText("AppLngList") = "" Then
						DlgEnable "AddLangButton",False
						DlgEnable "AddAllLangButton",False
						DlgEnable "EditAppLangButton",False
						DlgEnable "DelAppLangButton",False
						DlgText "AppLngText",Replace$(MsgList(23),"%s","0")
					Else
						DlgEnable "AddLangButton",True
						DlgEnable "AddAllLangButton",True
						DlgEnable "EditAppLangButton",True
						DlgEnable "DelAppLangButton",True
						DlgText "AppLngText",Replace$(MsgList(23),"%s",CStr$(DlgListBoxArray("AppLngList")))
					End If
					If DlgText("UseLngList") = "" Then
						DlgEnable "DelLangButton",False
						DlgEnable "DelAllLangButton",False
						DlgEnable "EditUseLangButton",False
						DlgEnable "DelUseLangButton",False
						DlgText "UseLngText",Replace$(MsgList(24),"%s","0")
					Else
						DlgEnable "DelLangButton",True
						DlgEnable "DelAllLangButton",True
						DlgEnable "EditUseLangButton",True
						DlgEnable "DelUseLangButton",True
						DlgText "UseLngText",Replace$(MsgList(24),"%s",CStr$(DlgListBoxArray("UseLngList")))
					End If
				End If
				If DlgValue("AsiaKeyBox") = 1 Then
					DlgEnable "AddAcckeyBox",False
					DlgValue "AddAcckeyBox",0
				Else
					DlgEnable "AddAcckeyBox",True
				End If
				n = -1
				For i = 0 To UBound(DefaultCheckList)
					If DefaultCheckList(i) = .Name Then
						n = i
						Exit For
					End If
				Next i
				If n > -1 Then
					DlgEnable "ChangButton",False
					DlgEnable "DelButton",False
				Else
					DlgEnable "ChangButton",True
					DlgEnable "DelButton",IIf(UBound(CheckList) = 0,False,True)
				End If
			End With
		Case 1
			Select Case DlgItem$
			Case "ExeBrowseButton"
				If PSL.SelectFile(Temp,True,MsgList(26),MsgList(25)) = False Then Exit Function
				DlgText "CmdPathBox",Temp
				If InStr(LCase$(Temp),"winrar.exe") Then
					DlgText "ArgumentBox","e -ibck ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"winzip.exe") Then
					DlgText "CmdPathBox",strReplace(Temp,"WinZip.exe","WzunZip.exe")
					DlgText "ArgumentBox"," ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"wzunzip.exe") Then
					DlgText "ArgumentBox"," ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"7z.exe") Then
					DlgText "ArgumentBox","e -r ""%1"" -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"7zfm.exe") Then
					DlgText "CmdPathBox",strReplace(Temp,"7zFM.exe","7z.exe")
					DlgText "ArgumentBox","e -r ""%1"" -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"haozip.exe") Then
					DlgText "CmdPathBox",strReplace(Temp,"HaoZip.exe","HaoZipC.exe")
					DlgText "ArgumentBox","e ""%1"" -r -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"haozipc.exe") Then
					DlgText "ArgumentBox","e ""%1"" -r -o""%3"" %2"
				End If
			Case "ArgumentButton"
				ReDim TempList(2) As String
				TempList(0) = MsgList(28)
				TempList(1) = MsgList(29)
				TempList(2) = MsgList(30)
				Select Case ShowPopupMenu(TempList,vbPopupUseRightButton)
				Case Is < 0
					Exit Function
				Case 0
					DlgText "ArgumentBox",DlgText("ArgumentBox")  & " " & """%1"""
				Case 1
					DlgText "ArgumentBox",DlgText("ArgumentBox")  & " " & """%2"""
				Case Else
					DlgText "ArgumentBox",DlgText("ArgumentBox")  & " " & """%3"""
				End Select
			Case "ResetButton"
				ReDim TempList(1) As String
				TempList(0) = MsgList(1)
				TempList(1) = MsgList(2)
				Select Case ShowPopupMenu(TempList,vbPopupUseRightButton)
				Case Is < 0
					Exit Function
				Case 0
					DlgValue "UpdateSet",1
					DlgText "WebSiteBox",updateMainUrl & vbCrLf & updateMinorUrl
					TempList = ReSplit(getCMDPath(".rar","",""),JoinStr)
					DlgText "CmdPathBox",TempList(0)
					DlgText "ArgumentBox",TempList(1)
					DlgText "UpdateCycleBox","7"
				Case 1
					DlgValue "UpdateSet",StrToLong(UpdateSetBak(0))
					DlgText "WebSiteBox",UpdateSetBak(1)
					DlgText "CmdPathBox",UpdateSetBak(2)
					DlgText "ArgumentBox",UpdateSetBak(3)
					DlgText "UpdateCycleBox",UpdateSetBak(4)
				End Select
			Case "CleanButton"
	    		DlgText "WebSiteBox",""
	    		DlgText "CmdPathBox",""
				DlgText "ArgumentBox",""
			Case "CheckButton"
				If DlgText("CmdPathBox") = "" Or DlgText("ArgumentBox") = "" Then
	    			MsgBox(MsgList(27),vbOkOnly+vbInformation,MsgList(0))
					Exit Function
	    		End If
				i = Download(UpdateSet,DlgText("WebSiteBox"),3,-2)
	    		If i < 1 Then Exit Function
	    		j = 0
	    		If UpdateSet(5) < Format(Date,"yyyy-MM-dd") Then
	    			j = 1
	    		ElseIf i = 3 And ArrayComp(UpdateSet,UpdateSetBak) = False Then
	    			j = 1
	    		End If
	    		If j = 1 Then
					DlgText "UpdateDateBox",Format(Date,"yyyy-MM-dd")
					UpdateSet(5) = DlgText("UpdateDateBox")
					Temp = IIf(DlgValue("cWriteType") = 0,CheckFilePath,CheckRegKey)
					If WriteCheckSet(Temp,"Update") = False Then
						MsgBox Replace$(MsgList(17),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
						Exit Function
					Else
						UpdateSetBak(5) = UpdateSet(5)
					End If
				End If
				If i = 3 Then Call ExitMacro(1)
				Exit Function
			Case "TestButton"
				If DlgText("CmdPathBox") = "" Or DlgText("ArgumentBox") = "" Then
	    			MsgBox(MsgList(17),vbOkOnly+vbInformation,MsgList(0))
	    			Exit Function
	    		End If
	    		Download(UpdateSet,DlgText("WebSiteBox"),4,-2)
	    		Exit Function
	    	End Select
			UpdateSet(0) = DlgValue("UpdateSet")
			UpdateSet(1) = DlgText("WebSiteBox")
			UpdateSet(2) = DlgText("CmdPathBox")
			UpdateSet(3) = DlgText("ArgumentBox")
			UpdateSet(4) = DlgText("UpdateCycleBox")
			UpdateSet(5) = DlgText("UpdateDateBox")
			If UpdateSet(5) = MsgList(4) Then UpdateSet(5) = ""
		Case 2
			Select Case DlgItem$
			Case "UILangList"
				HeaderID = DlgValue("UILangList")
				If HeaderID < 0 Then Exit Function
				If HeaderID > 1 Then
					If LCase$(cSelected(0)) = LCase$(UIFileList(HeaderID - 2).LangID) Then Exit Function
				Else
					If cSelected(0) = CStr$(HeaderID) Then Exit Function
				End If
			Case "EditUILangButton"
				ReDim FileDataList(UBound(UIFileList)) As String
				For i = 0 To UBound(UIFileList)
					FileDataList(i) = UIFileList(i).FilePath & JoinStr & "unicodeFFFE"
				Next i
				If EditFile(LangFile,FileDataList,True) = False Then Exit Function
				If GetUIList(MacroLoc & "\Data\",UIFileList) = False Then Exit Function
				HeaderID = DlgValue("UILangList")
			Case "MainFontButton","SrcStrFontButton","TrnStrFontButton"
				HeaderID = CLng(DlgText("SuppValueBox"))
				Select Case DlgItem$
				Case "MainFontButton"
					i = 0
				Case "SrcStrFontButton"
					i = 1
				Case "TrnStrFontButton"
					i = 2
				End Select
				ReDim TempList(2) As String
				TempList(0) = MsgList(1)
				TempList(1) = MsgList(2)
				TempList(2) = MsgList(35)
				Select Case ShowPopupMenu(TempList,vbPopupUseRightButton)
				Case Is < 0
					Exit Function
				Case 0	'Ĭ
					If CheckFont(LFList(i)) = False Then Exit Function
					ReDim tmpLFList(0) As LOG_FONT
					LFList(i) = tmpLFList(0)
				Case 1	'ԭֵ
					If FontComp(LFList(i),LFListBak(i)) = False Then Exit Function
					LFList(i) = LFListBak(i)
				Case 2	'Զ
					If SelectFont(HeaderID,LFList(i)) = 0 Then Exit Function
				End Select
				DlgText Replace$(DlgItem$,"Button","Box"),GetFontText(HeaderID,LFList(i))
				If DlgItem$ <> "MainFontButton" Then Exit Function
				'岢ӦõԻ
				j = CreateFont(HeaderID,LFList(0))
				If j = 0 Then Exit Function
				For i = 0 To DlgCount() - 1
					n = GetDlgItem(HeaderID,DlgControlId(DlgName(i)))
					SendMessageLNG(n,WM_SETFONT,j,0)
				Next i
				DrawWindow(HeaderID,j)
				Exit Function
			Case Else
				Exit Function
			End Select

			If HeaderID > 1 Then
				Temp = UIFileList(HeaderID - 2).FilePath
			Else
				If HeaderID = 0 Then
					n = Val("&H" & OSLanguage)
				Else
					n = PSL.Option(pslOptionSystemLanguage)
				End If
				For i = 0 To UBound(UIFileList)
					TempList = ReSplit(LCase$(UIFileList(i).LangID),";")
					For j = 0 To UBound(TempList)
						If Val("&H" & TempList(j)) = n Then
							Temp = UIFileList(i).FilePath
							Exit For
						End If
					Next j
					If Temp <> "" Then Exit For
				Next i
			End If
			If Temp = "" Then Exit Function
			If Dir$(Temp) = "" Then Exit Function
			If getINIFile(UIDataList,Temp,"unicodeFFFE",0) = False Then Exit Function
			If DlgItem$ = "UILangList" Then
				If HeaderID < 2 Then
					cSelected(0) = CStr(HeaderID)
				Else
					cSelected(0) = UIFileList(HeaderID - 2).LangID
				End If
			End If
			LangFile = Temp

			'»ȡַб
			CodeList = getCodePageList(0,49)
			'öԻִ
			If getMsgList(UIDataList,MsgList,"Settings",1) = True Then
				DlgText -1,MsgList(0)
				DlgText "MainText",MsgList(1)
				DlgText "StrHandle",MsgList(2)
				DlgText "AutoUpdate",MsgList(3)
				DlgText "UILangListSet",MsgList(4)

				DlgText "GroupBox1",MsgList(5)
				DlgText "LevelButton",MsgList(6)
				DlgText "AddButton",MsgList(7)
				DlgText "ChangButton",MsgList(8)
				DlgText "DelButton",MsgList(9)

				DlgText "GroupBox2",MsgList(10)
				DlgText "cWriteToFile",MsgList(11)
				DlgText "cWriteToRegistry",MsgList(12)
				DlgText "ImportButton",MsgList(13)
				DlgText "ExportButton",MsgList(14)

				DlgText "GroupBox3",MsgList(15)
				DlgText "SetItemText",MsgList(16)
				DlgText "NextSetType",MsgList(17)

				DlgText "AccKeyBoxTxt",MsgList(18)
				DlgText "ExCrBoxTxt",MsgList(19)
				DlgText "ChkBktBoxTxt",MsgList(20)
				DlgText "KpPairBoxTxt",MsgList(21)
				DlgText "AsiaKeyBox",MsgList(22)
				DlgText "AddAcckeyBox",MsgList(23)

				DlgText "ChkEndBoxTxt",MsgList(24)
				DlgText "NoTrnEndBoxTxt",MsgList(25)
				DlgText "AutoTrnEndBoxTxt",MsgList(26)

				DlgText "ShortBoxTxt",MsgList(27)
				DlgText "ShortKeyBoxTxt",MsgList(28)
				DlgText "KpShortKeyBoxTxt",MsgList(29)

				DlgText "PreRepStrBoxTxt",MsgList(30)
				DlgText "AutoWebFlagBoxTxt",MsgList(31)

				DlgText "LineSplitBoxTxt",MsgList(32)
				DlgText "PreInsertSplitBoxTxt",MsgList(33)
				DlgText "AppInsertSplitBoxTxt",MsgList(34)
				DlgText "ReplaceSplitBoxTxt",MsgList(35)
				DlgText "LineSplitModeBox",MsgList(36)

				DlgText "AppLngText",MsgList(37)
				DlgText "UseLngText",MsgList(38)
				DlgText "AddLangButton",MsgList(39)
				DlgText "AddAllLangButton",MsgList(40)
				DlgText "DelLangButton",MsgList(41)
				DlgText "DelAllLangButton",MsgList(42)
				DlgText "SetAppLangButton",MsgList(43)
				DlgText "EditAppLangButton",MsgList(44)
				DlgText "DelAppLangButton",MsgList(45)
				DlgText "SetUseLangButton",MsgList(46)
				DlgText "EditUseLangButton",MsgList(47)
				DlgText "DelUseLangButton",MsgList(48)

				DlgText "UpdateSetGroup",MsgList(49)
				DlgText "AutoButton",MsgList(50)
				DlgText "ManualButton",MsgList(51)
				DlgText "OffButton",MsgList(52)
				DlgText "CheckGroup",MsgList(53)
				DlgText "UpdateCycleText",MsgList(54)
				DlgText "UpdateDatesText",MsgList(55)
				DlgText "UpdateDateText",MsgList(56)
				DlgText "CheckButton",MsgList(57)
				DlgText "WebSiteGroup",MsgList(58)
				DlgText "CmdGroup",MsgList(59)
				DlgText "CmdPathBoxText",MsgList(60)
				DlgText "ArgumentBoxText",MsgList(61)
				DlgText "ExeBrowseButton",MsgList(6)
				DlgText "ArgumentButton",MsgList(62)

				DlgText "UILangSetGroup",MsgList(63)
				DlgText "UILangSetText1",MsgList(64)
				DlgText "UILangSetText2",MsgList(65)
				DlgText "UILangSetText3",MsgList(66)

				DlgText "UIFontSetGroup",MsgList(67)
				DlgText "MainFontText",MsgList(68)
				DlgText "MainFontButton",MsgList(69)

				DlgText "HelpButton",MsgList(70)
				DlgText "ResetButton",MsgList(71)
				DlgText "TestButton",MsgList(72)
				DlgText "CleanButton",MsgList(73)
				DlgText "EditUILangButton",MsgList(74)
			End If
			'öԻִ
			If getMsgList(UIDataList,MsgList,"SettingsDlgFunc",1) = True Then
				TempList = ReSplit(MsgList(32),";")
				i = DlgValue("SetType")
				DlgListBoxArray "SetType",TempList()
				DlgValue "SetType",i

				ReDim TempList(UBound(UIFileList) + 2) As String
				For i = 0 To UBound(UIFileList) + 2
					Select Case i
					Case 0
						TempList(i) = MsgList(33)
					Case 1
						TempList(i) = MsgList(34)
					Case Else
						TempList(i) = UIFileList(i - 2).LangName
					End Select
				Next i
				DlgListBoxArray "UILangList",TempList()
				DlgValue "UILangList",HeaderID
			End If
			'Իִ
			If getMsgList(UIDataList,MsgList,"Main",1) = True Then
				'滻
				TempList = ReSplit(MsgList(4),";")
				For i = 0 To UBound(CheckList)
					Select Case CheckList(i).Name
					Case DefaultCheckList(0)
						CheckList(i).Name = TempList(0)
					Case DefaultCheckList(1)
						CheckList(i).Name = TempList(1)
					End Select
				Next i
				'滻ݷ
				For i = 0 To UBound(CheckListBak)
					Select Case CheckListBak(i).Name
					Case DefaultCheckList(0)
						CheckListBak(i).Name = TempList(0)
					Case DefaultCheckList(1)
						CheckListBak(i).Name = TempList(1)
					End Select
				Next i
				'滻ѡ
				Select Case cSelected(1)
				Case DefaultCheckList(0)
					cSelected(1) = TempList(0)
				Case DefaultCheckList(1)
					cSelected(1) = TempList(1)
				End Select
				Select Case cSelected(2)
				Case DefaultCheckList(0)
					cSelected(2) = TempList(0)
				Case DefaultCheckList(1)
					cSelected(2) = TempList(1)
				End Select
				'Ĭϼб
				DefaultCheckList(0) = TempList(0)
				DefaultCheckList(1) = TempList(1)
				n = DlgValue("CheckList")
				TempList = getSetNameList(CheckList)
				DlgListBoxArray "CheckList",TempList()
				DlgValue "CheckList",n
				'滻
				TempList = ReSplit(MsgList(5),";")
				For i = 0 To UBound(ProjectList)
					Select Case ProjectList(i).Name
					Case DefaultProjectList(0)
						ProjectList(i).Name = TempList(0)
					Case DefaultProjectList(1)
						ProjectList(i).Name = TempList(1)
					Case DefaultProjectList(2)
						ProjectList(i).Name = TempList(2)
					Case DefaultProjectList(3)
						ProjectList(i).Name = TempList(3)
					Case DefaultProjectList(4)
						ProjectList(i).Name = TempList(4)
					End Select
				Next i
				'滻ݷ
				For i = 0 To UBound(ProjectListBak)
					Select Case ProjectListBak(i).Name
					Case DefaultProjectList(0)
						ProjectListBak(i).Name = TempList(0)
					Case DefaultProjectList(1)
						ProjectListBak(i).Name = TempList(1)
					Case DefaultProjectList(2)
						ProjectListBak(i).Name = TempList(2)
					Case DefaultProjectList(3)
						ProjectListBak(i).Name = TempList(3)
					Case DefaultProjectList(4)
						ProjectListBak(i).Name = TempList(4)
					End Select
				Next i
				'ĬϷб
				DefaultProjectList(0) = TempList(0)
				DefaultProjectList(1) = TempList(1)
				DefaultProjectList(2) = TempList(2)
				DefaultProjectList(3) = TempList(3)
				DefaultProjectList(4) = TempList(4)
				'ֹͣťʱʾԻϵϢ
				StopTitle = MsgList(27)
				StopMsg = MsgList(28)
			End If
		End Select
	Case 3 ' ıϿı
		Select Case DlgValue("Options")
		Case 0
			If DlgValue("SetType") = 5 Then Exit Function
			j = DlgValue("CheckList")
			If j < 0 Then Exit Function
			With CheckList(j)
				Select Case DlgValue("SetType")
				Case 0
					.AccKeyChar = RemoveSpaces(DlgText("AccKeyBox"),",")
					.AccKeyExcludeChar = DlgText("ExCrBox")
					.CheckBracket = RemoveSpaces(DlgText("ChkBktBox"),",")
					.KeepCharPair = RemoveSpaces(DlgText("KpPairBox"),",")
					.ShowAsiaKey = DlgValue("AsiaKeyBox")
					.AccKeyWithFirstChar = DlgValue("AddAcckeyBox")
				Case 1
					.CheckEndChar = RemoveSpaces(DlgText("ChkEndBox")," ")
					.NotTrnEndChar = RemoveSpaces(DlgText("NoTrnEndBox"),",")
					.AutoTrnEndChar = RemoveSpaces(DlgText("AutoTrnEndBox")," ")
				Case 2
					.CheckShortChar = RemoveSpaces(DlgText("ShortBox"),",")
					.CheckShortKey = RemoveSpaces(DlgText("ShortKeyBox"),",")
					.KeepShortKey = RemoveSpaces(DlgText("KpShortKeyBox"),",")
				Case 3
					.PreRepStr = DlgText("PreRepStrBox")
					.AppRepStr = DlgText("AutoWebFlagBox")
				Case 4
					.LineSplitMode = DlgValue("LineSplitModeBox")
					.PreInsertSplitChar = RemoveSpaces(DlgText("PreInsertSplitBox"),",")
					.AppInsertSplitChar = RemoveSpaces(DlgText("AppInsertSplitBox"),",")
					.ReplaceSplitChar = RemoveSpaces(DlgText("ReplaceSplitBox"),",")
				End Select
			End With
		Case 1
			If getMsgList(UIDataList,MsgList,"SettingsDlgFunc",1) = False Then Exit Function
			Select Case DlgItem$
			Case "CmdPathBox"
				If DlgText("CmdPathBox") = "" Then
	    			MsgBox(MsgList(27),vbOkOnly+vbInformation,MsgList(0))
					Exit Function
				ElseIf Dir$(DlgText("CmdPathBox")) = "" Then
					MsgBox MsgList(9),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
	    		End If
				Temp = Trim(DlgText("CmdPathBox"))
				If InStr(LCase$(Temp),"winrar.exe") Then
					DlgText "ArgumentBox","e -ibck ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"winzip.exe") Then
					DlgText "CmdPathBox",strReplace(Temp,"WinZip.exe","WzunZip.exe")
					DlgText "ArgumentBox"," ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"wzunzip.exe") Then
					DlgText "ArgumentBox"," ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"7z.exe") Then
					DlgText "ArgumentBox","e -r ""%1"" -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"7zfm.exe") Then
					DlgText "ArgumentBox",strReplace(Temp,"7zFM.exe","7z.exe")
					DlgText "ArgumentBox","e -r ""%1"" -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"haozip.exe") Then
					DlgText "CmdPathBox",strReplace(Temp,"HaoZip.exe","HaoZipC.exe")
					DlgText "ArgumentBox","e ""%1"" -r -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"haozipc.exe") Then
					DlgText "ArgumentBox","e ""%1"" -r -o""%3"" %2"
				End If
				UpdateSet(2) = Temp
			Case "ArgumentBox"
				If DlgText("ArgumentBox") = "" Then
					MsgBox MsgList(27),vbInformation+vbOkOnly,MsgList(0)
					Exit Function
				End If
				UpdateSet(3) = DlgText("ArgumentBox")
			Case Else
				UpdateSet(0) = DlgValue("UpdateSet")
				UpdateSet(1) = DlgText("WebSiteBox")
				UpdateSet(4) = DlgText("UpdateCycleBox")
				UpdateSet(5) = DlgText("UpdateDateBox")
				If UpdateSet(5) = MsgList(4) Then UpdateSet(5) = ""
			End Select
		End Select
	End Select
End Function


'ӻ༭Զ
Private Function SetLang(LangSetList() As LANG_SET,ByVal LangID As Long,ByVal Mode As Boolean) As LANG_SET
	Dim i As Long,Temp As String,MsgList() As String
	If getMsgList(UIDataList,MsgList,"SetLang",1) = False Then Exit Function
	If LangID > -1 Then Temp = LangSetList(LangID).Name
	Begin Dialog UserDialog 390,168,IIf(Temp = "",MsgList(0),MsgList(1)),.LangDlgFunc ' %GRID:10,7,1,1
		Text 10,14,370,14,MsgList(2),.LangText
		TextBox 10,35,370,21,.LangName
		Text 10,77,370,14,MsgList(3),.CodeText
		TextBox 10,98,370,21,.SrcCode
		OKButton 90,140,80,21,.OKButton
		CancelButton 220,140,80,21,.CancelButton
	End Dialog
    Dim dlg As UserDialog
    If LangID > -1 Then
    	dlg.LangName = LangSetList(LangID).Name
    	dlg.SrcCode = LangSetList(LangID).PslCode
    End If
    StartDlg:
    If Dialog(dlg) = 0 Then Exit Function
	If LangID > -1 Then
		If dlg.SrcCode = "" Then
			MsgBox MsgList(5),vbOkOnly+vbInformation,MsgList(4)
			GoTo StartDlg
		End If
		If LCase$(dlg.SrcCode) <> LCase$(LangSetList(LangID).PslCode) Then
			For i = 0 To UBound(LangSetList)
				If LCase$(dlg.SrcCode) = LCase$(LangSetList(i).PslCode) Then
					MsgBox MsgList(8),vbOkOnly+vbInformation,MsgList(4)
					GoTo StartDlg
				End If
			Next i
		End If
	Else
		If dlg.LangName = "" Or dlg.SrcCode = "" Then
			MsgBox MsgList(6),vbOkOnly+vbInformation,MsgList(4)
			GoTo StartDlg
		End If
		For i = 0 To UBound(LangSetList)
			If LCase$(dlg.LangName) = LCase$(LangSetList(i).Name) Then
				MsgBox MsgList(7),vbOkOnly+vbInformation,MsgList(4)
				GoTo StartDlg
			ElseIf LCase$(dlg.SrcCode) = LCase$(LangSetList(i).PslCode) Then
				MsgBox MsgList(8),vbOkOnly+vbInformation,MsgList(4)
				GoTo StartDlg
			End If
		Next i
	End If
	SetLang.Name = dlg.LangName
	SetLang.PslCode = dlg.SrcCode
	SetLang.UseCode = IIf(Mode = False,"",dlg.SrcCode)
End Function


'Ա༭Ի
Private Function LangDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,LangName As String
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		LangName = LCase$(DlgText("LangName"))
		If LangName <> "" Then
			For i = 0 To UBound(PslLangList)
				If LCase$(PslLangList(i).Name) = LangName Then
					DlgEnable "LangName",False
					Exit For
				End If
			Next i
		End If
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 3 ' ıϿı
		Select Case DlgItem$
		Case "LangName"
			DlgText "LangName",Trim$(DlgText("LangName"))
		Case "SrcCode"
			DlgText "SrcCode",Trim$(DlgText("SrcCode"))
			If DlgText("SrcCode") = "" Then Exit Function
			If DlgText("LangName") <> "" Then Exit Function
			LangName = PSL.GetLangCode(PSL.GetLangID(DlgText("SrcCode"),pslCode639_1),pslCodeText)
			If LangName = "3FF3F" Then
				LangName = PSL.GetLangCode(PSL.GetLangID(DlgText("SrcCode"),pslCodeLangRgn),pslCodeText)
			End If
			If LangName <> "3FF3F" Then DlgText "LangName",LangName
		Case "TarnCode"
			DlgText "TarnCode",Trim$(DlgText("TarnCode"))
		End Select
	End Select
End Function


'ȼ
Private Function SetLevel(LevelList() As String,ByVal ID As Long,ByVal Msg As String) As Boolean
	Dim MsgList() As String
	If getMsgList(UIDataList,MsgList,"SetLevel",1) = False Then Exit Function
	UseStrList = LevelList
	AllStrList = LevelList
	Begin Dialog UserDialog 480,322,MsgList(0),.SetLevelDlgFunc ' %GRID:10,7,1,1
		Text 10,7,460,105,Msg
		ListBox 10,119,360,161,LevelList(),.LevelList
		PushButton 380,119,90,21,MsgList(1),.UpButton
		PushButton 380,147,90,21,MsgList(2),.DownButton
		PushButton 380,175,90,21,MsgList(3),.ResetButton
		OKButton 130,294,80,21,.OKButton
		CancelButton 280,294,80,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.LevelList = ID
	If Dialog(dlg) = 0 Then Exit Function
	If ArrayComp(UseStrList,AllStrList) = True Then
		SetLevel = True
		LevelList = UseStrList
	End If
	Erase UseStrList,AllStrList
End Function


'ȼԻ
Private Function SetLevelDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,Temp As String
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		If UBound(UseStrList) = 0 Then
			DlgEnable "UpButton",False
			DlgEnable "DownButton",False
		Else
			Select Case DlgValue("LevelList")
			Case Is < 0
				DlgEnable "UpButton",False
				DlgEnable "DownButton",False
			Case 0
				DlgEnable "UpButton",False
			Case DlgListBoxArray("LevelList") - 1
				DlgEnable "DownButton",False
			Case Else
				DlgEnable "DownButton",True
			End Select
		End If
		DlgEnable "ResetButton",False
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		SetLevelDlgFunc = True 'ֹ°ťرնԻ򴰿
		Select Case DlgItem$
		Case "CancelButton","OKButton"
			SetLevelDlgFunc = False
			Exit Function
		Case "UpButton"
			i = DlgValue("LevelList")
			If i = 0 Then Exit Function
			Temp = UseStrList(i)
			UseStrList(i) = UseStrList(i - 1)
			UseStrList(i - 1) = Temp
			DlgListBoxArray "LevelList",UseStrList()
			DlgValue "LevelList",i - 1
		Case "DownButton"
			i = DlgValue("LevelList")
			If i = UBound(UseStrList) Then Exit Function
			Temp = UseStrList(i)
			UseStrList(i) = UseStrList(i + 1)
			UseStrList(i + 1) = Temp
			DlgListBoxArray "LevelList",UseStrList()
			DlgValue "LevelList",i + 1
		Case "ResetButton"
			UseStrList = AllStrList
			DlgListBoxArray "LevelList",UseStrList()
			DlgValue "LevelList",0
		End Select
		If UBound(UseStrList) = 0 Then
			DlgEnable "UpButton",False
			DlgEnable "DownButton",False
		Else
			Select Case DlgValue("LevelList")
			Case Is < 0
				DlgEnable "UpButton",False
				DlgEnable "DownButton",False
			Case 0
				DlgEnable "UpButton",False
				DlgEnable "DownButton",True
			Case DlgListBoxArray("LevelList") - 1
				DlgEnable "UpButton",True
				DlgEnable "DownButton",False
			Case Else
				DlgEnable "UpButton",True
				DlgEnable "DownButton",True
			End Select
		End If
		DlgEnable "ResetButton",ArrayComp(UseStrList,AllStrList)
	End Select
End Function


'Լ
Private Sub CheckTest(ByVal CheckID As Long,ByVal ProjectID As Long)
	Dim MsgList() As String,TempList() As String,TempArry() As String
	If getMsgList(UIDataList,MsgList,"CheckTest",1) = False Then Exit Sub
	TempList = getSetNameList(CheckList)
	TempArry = getSetNameList(ProjectList)
	Begin Dialog UserDialog 660,518,MsgList(0),.CheckTestFunc ' %GRID:10,7,1,1
		GroupBox 10,42,640,126,"",.GroupBox
		Text 10,7,640,28,MsgList(1),.MainText
		Text 30,59,90,14,MsgList(2),.SetNameText
		DropListBox 130,56,300,21,TempList(),.CheckListBox
		CheckBox 450,59,180,14,MsgList(16),.RepStrBox
		Text 30,80,90,14,MsgList(3),.ProjectText
		DropListBox 130,77,300,21,TempArry(),.ProjectListBox
		Text 30,101,90,14,MsgList(4),.TrnListText
		DropListBox 130,98,300,21,TempList(),.TrnListBox
		Text 450,87,120,14,MsgList(5),.LineNumText
		TextBox 580,84,50,18,.LineNumBox
		Text 30,122,90,14,MsgList(6),.SpecifyText
		TextBox 130,119,300,21,.SpecifyTextBox
		Text 450,117,180,24,MsgList(7),.TypeTipText
		Text 30,147,90,14,MsgList(8),.TypeText
		CheckBox 130,147,110,14,MsgList(9),.AllCheckBox
		CheckBox 250,147,120,14,MsgList(10),.AcckeyCheckBox
		CheckBox 380,147,120,14,MsgList(11),.EndSharCheckBox
		CheckBox 510,147,120,14,MsgList(12),.ShortCheckBox
		TextBox 10,182,640,294,.InTextBox,1
		PushButton 10,490,100,21,MsgList(15),.HelpButton
		PushButton 120,490,100,21,MsgList(13),.TestButton
		PushButton 230,490,100,21,MsgList(14),.ClearButton
		CancelButton 550,490,100,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.CheckListBox = CheckID
	dlg.ProjectListBox = ProjectID
	If Dialog(dlg) = 0 Then Exit Sub
End Sub


'ԶԻ
Private Function CheckTestFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,MsgList() As String,TempSet As CHECK_PROJECT_SET
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		If trn.Project.TransLists.Count > 0 Then
			ReDim MsgList(trn.Project.TransLists.Count - 1) As String
			For i = 1 To trn.Project.TransLists.Count
				MsgList(i - 1) = trn.Project.TransLists(i).Title & " - " & _
								PSL.GetLangCode(trn.Project.TransLists(i).Language.LangID,pslCodeText)
			Next i
		Else
			DlgEnable "TestButton",False
		End If
		DlgListBoxArray "TrnListBox",MsgList()
		DlgText "TrnListBox",trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
		DlgText "LineNumBox","10"
		DlgValue "AllCheckBox",1
    	DlgEnable "ClearButton",False
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		CheckTestFunc = True 'ֹ°ťرնԻ򴰿
		Select Case DlgItem$
		Case "CancelButton"
			CheckTestFunc = False '°ťرնԻ򴰿
		Case "AllCheckBox"
			If DlgValue("AllCheckBox") = 1 Then
				DlgValue "AcckeyCheckBox",0
				DlgValue "EndSharCheckBox",0
				DlgValue "ShortCheckBox",0
			ElseIf DlgValue("AcckeyCheckBox") + DlgValue("EndSharCheckBox") + DlgValue("ShortCheckBox") = 0 Then
				DlgValue "AllCheckBox",1
			End If
		Case "AcckeyCheckBox", "EndSharCheckBox", "ShortCheckBox"
			If DlgValue("AcckeyCheckBox") = 1 Or DlgValue("EndSharCheckBox") = 1 Or DlgValue("ShortCheckBox") = 1 Then
				DlgValue "AllCheckBox",0
			Else
				DlgValue "AllCheckBox",1
			End If
		Case "TestButton"
			If getMsgList(UIDataList,MsgList,"CheckTest",1) = False Then Exit Function
			'ݷ
			i = DlgValue("CheckListBox")
			Dim CheckTest As CHECK_SET,ProjectTest As CHECK_PROJECT_SET
			CheckTest = CheckList(i)
			CheckList(i) = ConvertAndSortCheckSet(CheckList(i))
			'ִѡ
			j = DlgValue("ProjectListBox")
			ProjectTest = ProjectList(j)
			'üΪȫ
			ReDim TempList(0) As String
			TempList = cSelected
			cSelected(14) = DlgValue("AllCheckBox")
			cSelected(15) = DlgValue("AcckeyCheckBox")
			cSelected(16) = DlgValue("EndSharCheckBox")
			cSelected(17) = DlgValue("ShortCheckBox")
			DlgText "InTextBox",MsgList(17)
			DlgText "InTextBox",CheckTestStrings(i,j,DlgText("TrnListBox"), _
					StrToLong(DlgText("LineNumBox")),DlgValue("RepStrBox"),DlgText("SpecifyTextBox"))
			DlgEnable "ClearButton",IIf(DlgText("InTextBox") = "",False,True)
			'ԭ
			CheckList(i) = CheckTest
			ProjectList(j) = ProjectTest
			'üΪȫ
			cSelected = TempList
		Case "ClearButton"
			DlgText "InTextBox",""
			DlgEnable "ClearButton",False
		Case "HelpButton"
			Call Help("CheckTestHelp")
		End Select
	Case 3 ' ıϿı
		If DlgItem$ = "InTextBox" Then
			DlgEnable "ClearButton",IIf(DlgText("InTextBox") = "",False,True)
    	End If
	End Select
End Function


'ִбеִ
Function CheckTestStrings(ByVal CheckID As Long,ByVal ProjectID As Long,ByVal TrnListDec As String, _
					ByVal LineNum As Long,ByVal RepStr As Long,ByVal SpecifyText As String) As String
	Dim i As Long,j As Long,n As Long,srcString As String,trnString As String
	Dim MsgList() As String,TempList() As String,TempArray() As String
	Dim TrnList As PslTransList,Stemp As Boolean,Find As Boolean,Temp As String

	If getMsgList(UIDataList,MsgList,"CheckStrings",1) = False Then Exit Function

	'ȡѡķб
	Set TrnList = trn
	For i = 1 To trn.Project.TransLists.Count
		Set TrnList = trn.Project.TransLists(i)
		If TrnListDec = TrnList.Title & " - " & PSL.GetLangCode(TrnList.Language.LangID,pslCodeText) Then Exit For
	Next i

	If TrnList.SourceList.LastChange > TrnList.LastUpdate Then TrnList.Update
	If TrnList.StringCount < LineNum Then LineNum = TrnList.StringCount
	ReDim TempList(LineNum) As String
	For i = 1 To TrnList.StringCount
		'ȡԭĺͷִ
		If TrnList.String(i).Text <> "" Then
			srcString = TrnList.String(i).SourceText
			trnString = TrnList.String(i).Text

			'תת
			Stemp = False
			srcString = Convert(srcString)
			trnString = Convert(trnString)
			If trnString <> TrnList.String(i).Text Then Stemp = True
			Temp = trnString

			'ʼִ
			If SpecifyText <> "" Then
				TempArray = ReSplit(SpecifyText,";",-1)
				For j = 0 To UBound(TempArray)
					If Left(TempArray(j),1) <> "*" And Right(TempArray(j),1) <> "*" Then
						TempArray(j) = "*" & TempArray(j) & "*"
					End If
					If (trnString Like TempArray(j)) = True Then
						Find = True
						trnString = CheckHanding(CheckID,ProjectID,srcString,trnString)
						If trnString <> Temp Then Exit For
					End If
				Next j
			Else
				trnString = CheckHanding(CheckID,ProjectID,srcString,trnString)
			End If
			If RepStr = 1 Then trnString = ReplaceStr(CheckID,trnString,2,1)
			If Stemp = True Then trnString = ReConvert(trnString)

			'Ϣ
			If trnString <> "" And trnString <> TrnList.String(i).Text Then
				TempList(n) = MsgList(0) & TrnList.String(i).SourceText & vbCrLf & _
							MsgList(1) & TrnList.String(i).Text & vbCrLf & _
							MsgList(2) & trnString & vbCrLf & _
							MsgList(3) & CheckMassage(CheckID,ProjectID) & vbCrLf & _
							MsgList(4) & MsgList(4) & MsgList(4)
				n = n + 1
				If n = LineNum Then Exit For
			End If
		End If
	Next i
	If n > 0 Then
		CheckTestStrings = MsgList(5) & vbCrLf & MsgList(4) & MsgList(4) & MsgList(4) & vbCrLf & Join$(TempList,vbCrLf)
	Else
		If SpecifyText = "" Then
			CheckTestStrings = MsgList(6)
		ElseIf Find = True Then
			CheckTestStrings = MsgList(7)
		Else
			CheckTestStrings = MsgList(8)
		End If
	End If
End Function


'Ⲣ°汾
Private Function CheckUpdate(UpdateSet() As String,ByVal ShowMsg As Long) As Boolean
	Dim i As Long,j As Long,n As Long
	'ȡݲ°汾
	If CheckArray(UpdateSet) = True Then
		If UpdateSet(0) = "" Then UpdateSet(0) = "1"
		If UpdateSet(1) = "" Then UpdateSet(1) = updateMainUrl & vbCrLf & updateMinorUrl
		If UpdateSet(2) = "" Or (UpdateSet(2) <> "" And Dir$(UpdateSet(2)) = "") Then
			getCMDPath(".rar",UpdateSet(2),UpdateSet(3))
		End If
	Else
		UpdateSet = ReSplit("1" & JoinStr & updateMainUrl & vbCrLf & updateMinorUrl & JoinStr & _
					getCMDPath(".rar","","") & JoinStr & "7" & JoinStr,JoinStr)
	End If
	If UpdateSet(0) <> "" And UpdateSet(0) <> "2" Then
		If UpdateSet(5) <> "" Then
			i = CLng(DateDiff("d",CDate(UpdateSet(5)),Date))
			j = StrComp(Format(Date,"yyyy-MM-dd"),UpdateSet(5))
			If UpdateSet(4) <> "" Then n = i - CLng(UpdateSet(4))
		End If
		If UpdateSet(5) = "" Or (j = 1 And n >= 0) Then
			i = Download(UpdateSet,UpdateSet(1),StrToLong(UpdateSet(0)),ShowMsg)
			If i > 0 Then
				If UpdateSet(5) < Format(Date,"yyyy-MM-dd") Then
					UpdateSet(5) = Format(Date,"yyyy-MM-dd")
					WriteCheckSet(cWriteLoc,"Update")
				End If
				If i = 3 Then CheckUpdate = True
			End If
		End If
	End If
End Function


'Ⲣ°汾
'Mode: 0 = Զزװ, 1 = û, 2 = ر, 3 = ֶ 4 = , 5 = 
'ֵ = 0 ʧ, 1 = Ϣɹ, 2 = ļɹ, 3 = ³ɹ
Private Function Download(UpdateSet() As String,ByVal Url As String,ByVal Mode As Long,ByVal ShowMsg As Long) As Long
	Dim i As Long,j As Long,m As Long,n As Long
	Dim xmlHttp As Object,Body() As Byte,BodyBak() As Byte
	Dim UrlList() As String,TempList() As String,TempArray() As String,MsgList() As String
	Dim ExePath As String,Argument As String,Temp As String,UpdateData As INIFILE_DATA
	Dim WebVersion As String,WebBuild As String,IniBuild As String,TempPath As String

	If Mode = 2 Then Exit Function
	If getMsgList(UIDataList,MsgList,"Download",1) = False Then Exit Function

	'ȡѹͲ
	If CheckArray(UpdateSet) = True Then
		If Url = "" Then Url = UpdateSet(1)
		ExePath = Trim$(UpdateSet(2))
		Argument = UpdateSet(3)
	End If

	'ѹͲ
	If Mode < 5 Then
		If ShowMsg > 0 Then
			SetTextBoxString ShowMsg,IIf(Mode = 4,MsgList(22),MsgList(23))
		ElseIf ShowMsg < 0 Then
			PSL.OutputWnd.Clear
			PSL.Output IIf(Mode = 4,MsgList(22),MsgList(23))
		End If
	End If
	If ExePath = "" Then
		If Mode < 5 Then
			MsgBox(IIf(Mode <> 4,MsgList(1),MsgList(2)) & vbCrLf & MsgList(3),vbOkOnly+vbInformation,MsgList(0))
		End If
		Exit Function
	End If
	If Url = "" Or Argument = "" Then
		i = 1
	ElseIf InStr(Argument,"%1") = 0 Then
		i = 1
	'ElseIf InStr(Argument,"%2") = 0 Then
	'	i = 1
	ElseIf InStr(Argument,"%3") = 0 Then
		i = 1
	End If
	If i = 1 Then
		If Mode < 5 Then
			MsgBox(IIf(Mode <> 4,MsgList(1),MsgList(2)) & vbCrLf & MsgList(4),vbOkOnly+vbInformation,MsgList(0))
		End If
		Exit Function
	End If

	'طǷ
	On Error Resume Next
	TempList = ReSplit(DefaultObject,";")
	For i = 0 To UBound(TempList)
		Set xmlHttp = CreateObject(TempList(i))
		If Not xmlHttp Is Nothing Then Exit For
	Next i
	If xmlHttp Is Nothing Then
		If Mode < 5 Then
			Err.Source = StrListJoin(TempList,"; ")
			Call sysErrorMassage(Err,2)
		End If
		Exit Function
	End If
	On Error GoTo 0

	'ȡϢ
	j = 0
	If Mode <> 4 Then
		'ϲļĬϺԶַ
		UrlList = ReSplit(Url,vbCrLf)
		For i = 0 To UBound(UrlList)
			Temp = Trim$(UrlList(i))
			n = InStrRev(Temp,"/")
			If n > 0 Then
				UrlList(i) = Left$(Temp,n) & updateINIFile
			End If
		Next i
		UrlList = ReSplit(updateINIMainUrl & vbCrLf & updateINIMinorUrl & vbCrLf & StrListJoin(UrlList,vbCrLf),vbCrLf)

		'زļ
		For i = 0 To UBound(UrlList)
			'ֵ1 = ɹ0 = ʧܣ-1 = ļڣ-2 = 
			Select Case DownloadFile(Body,xmlHttp,UrlList(i))
			Case 1
				Temp = BytesToBstr(Body,"utf-8")
				If Temp <> "" Then
					If InStr(LCase$(Temp),LCase$(AppName)) Then
						'ļ
						IniBuild = CheckUpdateINIFile(UpdateData,Temp)
						If IniBuild <> "" Then Exit For
					End If
				End If
			Case -2
				Set xmlHttp = Nothing
				If Mode < 5 Then MsgBox(MsgList(35),vbOkOnly+vbInformation,MsgList(0))
				Exit Function
			End Select
		Next i

		'ʾϢ
		If UpdateData.Title <> "" Then
			Download = 1
			Select Case StrComp(UpdateData.Title,Version) + StrComp(IniBuild,Build)
			Case Is > 0
				If Mode = 1 Or Mode = 3 Then
					Temp = Replace$(Replace$(MsgList(15),"%s",UpdateData.Title),"%d",IniBuild) & vbCrLf & vbCrLf & MsgList(20)
					If MsgBox(Temp & vbCrLf & StrListJoin(UpdateData.Value,vbCrLf),vbYesNo+vbInformation,MsgList(17)) = vbNo Then
						Set xmlHttp = Nothing
						Exit Function
					End If
				End If
			Case 0
				If Mode = 3 Then
					Temp = Replace$(Replace$(MsgList(14),"%s",UpdateData.Title),"%d",IniBuild) & vbCrLf & MsgList(21)
					If MsgBox(Temp,vbYesNo+vbInformation,MsgList(17)) = vbNo Then
						Set xmlHttp = Nothing
						Exit Function
					End If
				Else
					Set xmlHttp = Nothing
					Exit Function
				End If
			Case Is < 0
				If Mode = 3 Then
					MsgBox Replace$(Replace$(MsgList(14),"%s",UpdateData.Title),"%d",IniBuild),vbOkOnly+vbInformation,MsgList(16)
				End If
				Set xmlHttp = Nothing
				Exit Function
			End Select
		End If
	End If

	'سļ
	If Mode < 4 Then
		If ShowMsg > 0 Then
			SetTextBoxString ShowMsg,MsgList(24),True
		ElseIf ShowMsg < 0 Then
			PSL.Output MsgList(24)
		End If
	End If
	m = 0: n = 0: j = 0
	If UpdateData.Title <> "" Then
		UrlList = ClearTextArray(ReSplit(Url & vbCrLf & StrListJoin(UpdateData.Item,vbCrLf),vbCrLf),True)
	Else
		UrlList = ReSplit(Url,vbCrLf)
	End If
	For i = 0 To UBound(UrlList)
		If UrlList(i) <> "" Then
			'ֵ1 = ɹ0 = ʧܣ-1 = ļڣ-2 = 
			Select Case DownloadFile(Body,xmlHttp,UrlList(i))
			Case 1
				If Mode <> 4 Then Exit For
				If LenB(BodyBak) = 0 Then BodyBak = Body
			Case 0
				If Mode = 4 Then
					ReDim Preserve TempList(m) As String
					TempList(m) = UrlList(i)
				End If
				m = m + 1
			Case -1
				If Mode = 4 Then
					ReDim Preserve TempArray(n) As String
					TempArray(n) = UrlList(i)
				End If
				n = n + 1
			Case -2
				If Mode < 5 Then MsgBox(MsgList(35),vbOkOnly+vbInformation,MsgList(0))
				Set xmlHttp = Nothing
				Exit Function
			End Select
			j = j + 1
		End If
	Next i
	If m + n <> 0 Then
		If Mode <> 4 Then
			If m = j Or n = j Then
				If Mode < 5 Then MsgBox(MsgList(1) & vbCrLf & IIf(n = j,MsgList(5),MsgList(6)),vbOkOnly+vbInformation,MsgList(0))
				Set xmlHttp = Nothing
				Exit Function
			End If
		Else
			If m <> 0 And n <> 0 Then
				Temp = MsgList(2) & vbCrLf & MsgList(33) & vbCrLf & StrListJoin(TempArray,vbCrLf) & _
						vbCrLf & vbCrLf & MsgList(34) & vbCrLf & StrListJoin(TempList,vbCrLf)
			ElseIf m <> 0 Then
				Temp = MsgList(2) & vbCrLf & MsgList(34) & vbCrLf & StrListJoin(TempList,vbCrLf)
			ElseIf n <> 0 Then
				Temp = MsgList(2) & vbCrLf & MsgList(33) & vbCrLf & StrListJoin(TempArray,vbCrLf)
			End If
			MsgBox(Temp,vbOkOnly+vbInformation,MsgList(12))
			Set xmlHttp = Nothing
			Exit Function
		End If
	End If
	Set xmlHttp = Nothing

	'صĳļ
	If Mode = 4 Then Body = BodyBak
	TempPath = MacroLoc & "\temp\"
	Temp = TempPath & "temp.rar"
	On Error Resume Next
	If Dir$(TempPath & "*.*") = "" Then MkDir TempPath
	If BytesToFile(Body,Temp) = False Then
		i = FreeFile
		Open Temp For Binary Access Write As #i
		Put #i,,Body
		Close #i
	End If
	On Error GoTo 0

	'ѹļ
	i = 0
	If Dir$(Temp) <> "" Then
		i = ExtractFile(Temp,TempPath,ExePath,Argument)
		If i = 1 Then
			Temp = TempPath & updateMainFile
		ElseIf Mode < 5 Then
			If i = -2 Then
				Temp = Mid$(Left$(ExePath,InStrRev(ExePath,".") - 1),InStrRev(ExePath,"\") + 1)
				Temp = Replace$(MsgList(8),"%s",Temp) & vbCrLf & _
						Replace$(MsgList(9),"%s",ExePath) & vbCrLf & _
						Replace$(MsgList(10),"%s",Argument) & vbCrLf & vbCrLf & MsgList(11)
				MsgBox(Temp,vbOkOnly+vbInformation,MsgList(0))
			ElseIf i = -3 Then
				MsgBox(IIf(Mode <> 4,MsgList(1),MsgList(2)) & vbCrLf & MsgList(7),vbOkOnly+vbInformation,MsgList(0))
			End If
		End If
	End If
	If i <> 1 Then
		DelDirs(TempPath)
		Exit Function
	End If

	'ȡصĳ汾
	If Mode < 4 Then
		If ShowMsg > 0 Then
			SetTextBoxString ShowMsg,MsgList(26),True
		ElseIf ShowMsg < 0 Then
			PSL.Output MsgList(26)
		End If
	End If
	WebVersion = GetWebVersion(Temp,"Const Version = ")
	WebBuild = GetWebVersion(Temp,"Const Build = ")
	If WebVersion = "" Or WebBuild = "" Then
		If Mode < 5 Then MsgBox(MsgList(19),vbOkOnly+vbInformation,MsgList(0))
		DelDirs(TempPath)
		Exit Function
	End If

	'Ƚϰ汾ʾϢ
	If Url <> StrListJoin(UrlList,vbCrLf) Then UpdateSet(1) = StrListJoin(UrlList,vbCrLf)
	If Mode = 4 Then
		MsgBox(MsgList(13) & vbCrLf & Replace$(Replace$(MsgList(14),"%s",WebVersion),"%d",WebBuild),vbOkOnly+vbInformation,MsgList(12))
		Download = 2
		DelDirs(TempPath)
		Exit Function
	End If
	n = StrComp(WebVersion,Version) + StrComp(WebBuild,Build)
	If Mode < 5 Then
		If n > 0 Or (n = 0 And Mode = 3) Then
			If UpdateData.Title = "" Then
				If Mode = 1 Then
					Temp = Replace$(Replace$(MsgList(15),"%s",WebVersion),"%d",WebBuild)
				ElseIf Mode = 3 Then
					If n = 0 Then
						Temp = Replace$(Replace$(MsgList(14),"%s",WebVersion),"%d",WebBuild) & vbCrLf & MsgList(21)
					Else
						Temp = Replace$(Replace$(MsgList(15),"%s",WebVersion),"%d",WebBuild)
					End If
				End If
				If MsgBox(Temp,vbYesNo+vbInformation,MsgList(17)) = vbNo Then
					DelDirs(TempPath)
					Exit Function
				End If
			ElseIf UpdateData.Title <> WebVersion Or IniBuild <> WebBuild Then
				Temp = MsgList(1) & vbCrLf & Replace$(Replace$(MsgList(29),"%s",WebVersion),"%d",WebBuild) & vbCrLf & MsgList(32)
				MsgBox(Temp,vbOkOnly+vbInformation,MsgList(0))
				DelDirs(TempPath)
				Exit Function
			End If
		Else
			If Mode < 2 Then
				If ShowMsg > 0 Then
					SetTextBoxString ShowMsg,Replace$(Replace$(MsgList(30),"%s",WebVersion),"%d",WebBuild),True
				ElseIf ShowMsg < 0 Then
					PSL.Output Replace$(Replace$(MsgList(30),"%s",WebVersion),"%d",WebBuild)
				End If
			Else
				MsgBox Replace$(Replace$(MsgList(31),"%s",WebVersion),"%d",WebBuild),vbOkOnly+vbInformation,MsgList(16)
			End If
			DelDirs(TempPath)
			Exit Function
		End If
	ElseIf n < 1 Then
		DelDirs(TempPath)
		Exit Function
	End If

	'װ°汾
	If Mode < 5 Then
		If ShowMsg > 0 Then
			SetTextBoxString ShowMsg,MsgList(27),True
		ElseIf ShowMsg < 0 Then
			PSL.Output MsgList(27)
		End If
		If SetupNewVersion(TempPath,MacroLoc) = True Then
			If ShowMsg > 0 Then
				SetTextBoxString ShowMsg,MsgList(28),True
			ElseIf ShowMsg < 0 Then
				PSL.Output MsgList(28)
			End If
			MsgBox(MsgList(18),vbOkOnly+vbInformation,MsgList(17))
			Download = 3
		End If
	ElseIf SetupNewVersion(TempPath,MacroLoc) = True Then
		Download = 3
	End If
	DelDirs(TempPath)
End Function


'עлȡ RAR չĬϳ
Public Function getCMDPath(ByVal ExtName As String,CmdPath As String,Argument As String) As String
	Dim i As Long,WshShell As Object,TempArray() As String
	On Error Resume Next
	Set WshShell = CreateObject("WScript.Shell")
	If WshShell Is Nothing Then
		getCMDPath = CmdPath & JoinStr & Argument
		Err.Source = "WScript.Shell"
		Call sysErrorMassage(Err,2)
		Exit Function
	End If
	ExtName = WshShell.RegRead("HKCR\" & ExtName & "\")
	If ExtName <> "" Then
		CmdPath = WshShell.RegRead("HKCR\" & ExtName & "\shell\open\command\")
	End If
	On Error GoTo 0
	Set WshShell = Nothing
	If CmdPath <> "" Then
		i = InStr(CmdPath,".")
		If i > 0 Then Argument = Trim$(Mid$(CmdPath,InStr(i,CmdPath," ")))
		CmdPath = Left$(CmdPath,Len(CmdPath) - Len(Argument))
		TempArray = ReSplit(CmdPath,"%")
		If UBound(TempArray) = 2 Then
			CmdPath = Replace$(CmdPath,"%" & TempArray(1) & "%",Environ(TempArray(1)),,1)
		End If
		CmdPath = RemoveBackslash(CmdPath,"""","""",1)

		If InStr(CmdPath,"\") = 0 Then
			If Dir$(Environ("SystemRoot") & "\system32\" & CmdPath) <> "" Then
				CmdPath = Environ("SystemRoot") & "\system32\" & CmdPath
			ElseIf Dir$(Environ("SystemRoot") & "\" & CmdPath) <> "" Then
				CmdPath = Environ("SystemRoot") & "\" & CmdPath
			End If
		End If

		If InStr(LCase$(CmdPath),"winrar.exe") Then
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = "e -ibck " & Replace$(Argument,"""%1""","""%1"" %2 ""%3""")
				ElseIf InStr(Argument,"%1") Then
					Argument = "e -ibck " & Replace$(Argument,"%1","""%1"" %2 ""%3""")
				Else
					Argument = "e -ibck ""%1"" %2 ""%3"" " & Argument
				End If
			Else
				Argument = "e -ibck ""%1"" %2 ""%3"""
			End If
		ElseIf InStr(LCase$(CmdPath),"winzip.exe") Then
			CmdPath = strReplace(CmdPath,"WinZip.exe","WzunZip.exe")
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = Replace$(Argument,"""%1""","""%1"" %2 ""%3""")
				ElseIf InStr(Argument,"%1") Then
					Argument = Replace$(Argument,"%1","""%1"" %2 ""%3""")
				Else
					Argument = """%1"" %2 ""%3"" " & Argument
				End If
			Else
				Argument = " ""%1"" %2 ""%3"""
			End If
		ElseIf InStr(LCase$(CmdPath),"wzunzip.exe") Then
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = Replace$(Argument,"""%1""","""%1"" %2 ""%3""")
				ElseIf InStr(Argument,"%1") Then
					Argument = Replace$(Argument,"%1","""%1"" %2 ""%3""")
				Else
					Argument = """%1"" %2 ""%3"" " & Argument
				End If
			Else
				Argument = " ""%1"" %2 ""%3"""
			End If
		ElseIf InStr(LCase$(CmdPath),"7z.exe") Then
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = "e -r " & Replace$(Argument,"""%1""","""%1"" -o""%3"" %2")
				ElseIf InStr(Argument,"%1") Then
					Argument = "e -r " & Replace$(Argument,"%1","""%1"" -o""%3"" %2")
				Else
					Argument = "e -r ""%1"" -o""%3"" %2 " & Argument
				End If
			Else
				Argument = "e -r ""%1"" -o""%3"" %2"
			End If
		ElseIf InStr(LCase$(CmdPath),"7zfm.exe") Then
			CmdPath = strReplace(CmdPath,"7zFM.exe","7z.exe")
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = "e -r " & Replace$(Argument,"""%1""","""%1"" -o""%3"" %2")
				ElseIf InStr(Argument,"%1") Then
					Argument = "e -r " & Replace$(Argument,"%1","""%1"" -o""%3"" %2")
				Else
					Argument = "e -r ""%1"" -o""%3"" %2 " & Argument
				End If
			Else
				Argument = "e -r ""%1"" -o""%3"" %2"
			End If
		ElseIf InStr(LCase$(CmdPath),"haozip.exe") Then
			CmdPath = strReplace(CmdPath,"HaoZip.exe","HaoZipC.exe")
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = "e " & Replace$(Argument,"""%1""","""%1"" -r -o""%3"" %2")
				ElseIf InStr(Argument,"%1") Then
					Argument = "e " & Replace$(Argument,"%1","""%1"" -r -o""%3"" %2")
				Else
					Argument = "e ""%1"" -r -o""%3"" %2 " & Argument
				End If
			Else
				Argument = "e ""%1"" -r -o""%3"" %2"
			End If
		ElseIf InStr(LCase$(CmdPath),"haozipc.exe") Then
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = "e " & Replace$(Argument,"""%1""","""%1"" -r -o""%3"" %2")
				ElseIf InStr(Argument,"%1") Then
					Argument = "e " & Replace$(Argument,"%1","""%1"" -r -o""%3"" %2")
				Else
					Argument = "e ""%1"" -r -o""%3"" %2 " & Argument
				End If
			Else
				Argument = "e ""%1"" -r -o""%3"" %2"
			End If
		End If
	End If
	getCMDPath = CmdPath & JoinStr & Argument
End Function


'ļ
'ֵ1 = ɹ0 = ʧܣ-1 = ļڣ-2 = 
Private Function DownloadFile(Body() As Byte,xmlHttp As Object,ByVal Url As String) As Long
	Dim FileSize As Long
	ReDim Body(0) As Byte
	If Trim$(Url) = "" Then Exit Function
	On Error GoTo ExitFunction
	xmlHttp.Open "HEAD",Url,False,"",""
	xmlHttp.send()
	If OnReadyStateChange(xmlHttp,4,DefaultWaitTimes) = 4 Then
		'FileSize = CLng(ReSplit(xmlHttp.getResponseHeader("Content-Range"),"/")(1))
		FileSize = CLng(xmlHttp.getResponseHeader("Content-Length"))
	End If
	xmlHttp.Abort
	If FileSize > 0 Then
		xmlHttp.Open "GET",Url,False,"",""
		xmlHttp.setRequestHeader "Referer", Left$(Url, InStr(InStr(Url, "//") + 2, Url, "/") - 1)
		xmlHttp.setRequestHeader "Accept", "*/*"
		'xmlHttp.setRequestHeader "Range", "bytes = " & FileSize
		xmlHttp.setRequestHeader "Content-Type", "application/octet-stream"
		xmlHttp.setRequestHeader "If-Modified-Since", "0"
		xmlHttp.setRequestHeader "Pragma", "no-cache"
		xmlHttp.setRequestHeader "Cache-Control", "no-cache"
		xmlHttp.send()
		If OnReadyStateChange(xmlHttp,4,DefaultWaitTimes) = 4 Then
			If xmlHttp.Status = 200 Then
				Body = xmlHttp.responseBody
				If LenB(Body) = FileSize Then DownloadFile = 1
			End If
		End If
	Else
		DownloadFile = -1
	End If
	On Error GoTo 0
	ExitFunction:
	xmlHttp.Abort
	If Err.Number <> 0 Then DownloadFile = -2
End Function


'ļ
Private Function CheckUpdateINIFile(Data As INIFILE_DATA,ByVal UpdateINIText As String) As String
	Dim i As Long,j As Long,m As Long,n As Long
	Dim DefaultLng As String,LangName As String,DataList() As INIFILE_DATA

	If Trim$(UpdateINIText) = "" Then Exit Function
	If getINIFile(DataList,"",UpdateINIText,2) = False Then Exit Function
	For i = 0 To UBound(DataList)
		With DataList(i)
			Select Case .Title
			Case "Option"
				For j = 0 To UBound(.Item)
					If .Item(j) = "DefaultLanguage" Then
						DefaultLng = LCase$(Trim$(.Value(j)))
						Exit For
					End If
				Next j
			Case "Language"
				UpdateINIText = LCase$(OSLanguage)
				For j = 0 To UBound(.Item)
					If InStr(LCase$(.Value(j)),UpdateINIText) Then
						LangName = LCase$(.Item(j))
						Exit For
					End If
				Next j
				If LangName = "" Then LangName = DefaultLng
			Case AppName
				For j = 0 To UBound(.Item)
					UpdateINIText = LCase$(.Item(j))
					If UpdateINIText = "version" Then
						Data.Title = Trim$(.Value(j))
					ElseIf UpdateINIText = "build" Then
						CheckUpdateINIFile = Trim$(.Value(j))
					ElseIf InStr(UpdateINIText,"url_") Then
						ReDim Preserve Data.Item(m) 'As String
						Data.Item(m) = Trim$(.Value(j))
						m = m + 1
					ElseIf InStr(UpdateINIText,"des_" & LangName) Then
						ReDim Preserve Data.Value(n) 'As String
						Data.Value(n) = Trim$(.Value(j))
						n = n + 1
					End If
				Next j
				Exit For
			End Select
		End With
	Next i
	If m = 0 Or n = 0 Then
		CheckUpdateINIFile = ""
		Data.Title = ""
		ReDim Data.Item(0) 'As String,
		ReDim Data.Value(0) 'As String
	Else
		If CheckUpdateINIFile = "" Then CheckUpdateINIFile = Build
		ReDim Preserve Data.Item(m - 1) 'As String
		ReDim Preserve Data.Value(n - 1) 'As String
	End If
End Function


'ѹļ
'ֵ 1 = ɹ0 = ҪѹļڻСΪ㣬-1 = Ҳ-2 = ѹҲ-3 = ѹ
Private Function ExtractFile(ByVal File As String,ByVal Path As String,ByVal ExePath As String,ByVal Argument As String) As Long
	Dim WshShell As Object,TempList() As String

	On Error Resume Next
	Set WshShell = CreateObject("WScript.Shell")
	If WshShell Is Nothing Then
		Err.Source = "WScript.Shell"
		Call sysErrorMassage(Err,2)
		Exit Function
	End If
	On Error GoTo 0

	If Dir$(File) = "" Then Exit Function
	If FileLen(File) = 0 Then Exit Function
	If ExePath <> "" Then
		TempList = ReSplit(ExePath,"%",-1)
		If UBound(TempList) >= 2 Then
			ExePath = Replace$(ExePath,"%" & TempList(1) & "%",Environ(TempList(1)),,1)
		End If
		ExePath = RemoveBackslash(ExePath,"""","""",1)
	End If
	If Argument <> "" Then
		If InStr(Argument,"""%1""") Then Argument = Replace$(Argument,"%1",File)
		If InStr(Argument,"""%2""") Then Argument = Replace$(Argument,"%2","*")
		If InStr(Argument,"""%3""") Then Argument = Replace$(Argument,"%3",Path)
		If InStr(Argument,"%1") Then Argument = Replace$(Argument,"%1","""" & File & """")
		If InStr(Argument,"%2") Then Argument = Replace$(Argument,"%2","*")
		If InStr(Argument,"%3") Then Argument = Replace$(Argument,"%3","""" & Path & """")
	End If
	If ExePath <> "" Then
		If Dir$(ExePath) <> "" Then
			If WshShell.Run("""" & ExePath & """ " & Argument,0,True) = 0 Then
				ExtractFile = IIf(Dir$(Path & updateMainFile) <> "",1,-1)
			Else
				ExtractFile = -3
			End If
		Else
			ExtractFile = -2
		End If
	Else
		ExtractFile = -2
	End If
	Set WshShell = Nothing
End Function


'ȡصĳ汾
Private Function GetWebVersion(ByVal File As String,ByVal CheckStr As String) As String
	Dim n As Long,Temp As String,FN As Long
	On Error GoTo ExitFunction
	FN = FreeFile
	Open File For Input As #FN
	Do While Not EOF(FN)
		Line Input #FN,Temp
		n = InStr(Temp,CheckStr)
		If n > 0 Then
			GetWebVersion = Mid$(Temp,n + Len(CheckStr) + 1)
			GetWebVersion = Left$(GetWebVersion,Len(GetWebVersion) - 1)
			Exit Do
		End If
	Loop
	ExitFunction:
	On Error Resume Next
	Close #FN
End Function


'װ°汾
Private Function SetupNewVersion(ByVal FromPath As String,ByVal TargetDir As String) As Boolean
	Dim i As Long
	On Error GoTo ExitFunction
	If Right$(FromPath,1) <> "\" Then FromPath = FromPath & "\"

	'ǷӦĿ¼
	If Dir$(FromPath & "*.lng") <> "" Or Dir$(FromPath & "*.ini") <> "" Or Dir$(FromPath & "*.dat") <> "" Then
		If Dir$(TargetDir & "\Data\" & "*.*") = "" Then MkDir TargetDir & "\Data\"
	End If
	If Dir$(FromPath & "*.txt") <> "" Or Dir$(FromPath & "*.doc") <> "" Or Dir$(FromPath & "*.pdf") <> "" Then
		If Dir$(TargetDir & "\Doc\" & "*.*") = "" Then MkDir TargetDir & "\Doc\"
	End If
	If Dir$(FromPath & "mod*.bas") <> "" Or Dir$(FromPath & "*.cls") <> "" Then
		If Dir$(TargetDir & "\Module\" & "*.*") = "" Then MkDir TargetDir & "\Module\"
	End If
	If Dir$(FromPath & "*.chm") <> "" Or Dir$(FromPath & "*.hlp") <> "" Then
		If Dir$(TargetDir & "\Help\" & "*.*") = "" Then MkDir TargetDir & "\Help\"
	End If

	'ȡǰļУļУе°汾ļб
	ReDim FileList(0) As FILE_LIST
	If CheckArray(GetFiles(FileList,FromPath,"","*.*")) = False Then
		If CheckArray(getSubFiles(FileList,FromPath,"","*.*")) = False Then Exit Function
		SetupNewVersion = True
	End If
	Do
		'ƵǰļĿļ
		For i = 0 To UBound(FileList)
			Select Case LCase$(Mid$(FileList(i).sName,InStrRev(FileList(i).sName,".") + 1))
			Case "bas"
				If FileList(i).sName Like "mod*.bas" = False Then
					FileCopy FileList(i).FilePath,TargetDir & "\" & FileList(i).sName
				Else
					FileCopy FileList(i).FilePath,TargetDir & "\Module\" & FileList(i).sName
				End If
			Case "lng", "dat"
				FileCopy FileList(i).FilePath,TargetDir & "\Data\" & FileList(i).sName
			Case "obm", "cls"
				FileCopy FileList(i).FilePath,TargetDir & "\Module\" & FileList(i).sName
			Case "txt","doc","pdf"
				FileCopy FileList(i).FilePath,TargetDir & "\Doc\" & FileList(i).sName
				If Dir$(TargetDir & "\Data\" & FileList(i).sName) <> "" Then
					Kill TargetDir & "\Data\" & FileList(i).sName
				End If
			Case "ini"
				If Dir$(TargetDir & "\Data\" & FileList(i).sName) <> "" Then
					If FileDateTime(FileList(i).FilePath) > FileDateTime(TargetDir & "\Data\" & FileList(i).sName) Then
						FileCopy FileList(i).FilePath,TargetDir & "\Data\" & FileList(i).sName
					End If
				Else
					FileCopy FileList(i).FilePath,TargetDir & "\Data\" & FileList(i).sName
				End If
			Case "chm", "hlp"
				FileCopy FileList(i).FilePath,TargetDir & "\Help\" & FileList(i).sName
				If Dir$(TargetDir & "\Data\" & FileList(i).sName) <> "" Then
					Kill TargetDir & "\Data\" & FileList(i).sName
				End If
			Case Is <> "rar"
				FileCopy FileList(i).FilePath,TargetDir & "\Module\" & FileList(i).sName
			End Select
		Next i
		If SetupNewVersion = True Then Exit Do
		SetupNewVersion = True
		'ȡļе°汾ļб
		ReDim FileList(0) As FILE_LIST
		If CheckArray(getSubFiles(FileList,FromPath,"","*.*")) = False Then Exit Do
	Loop
	SetupNewVersion = True
	ExitFunction:
End Function


'ȡǰļеļб
'Mode = True Ƿ DefaultFile ΪΪ׸ļ
Private Function GetFiles(List() As FILE_LIST,ByVal DirPath As String,Optional ByVal DefaultFile As String, _
		Optional ByVal FindFile As String,Optional ByVal Mode As Boolean) As String()
	Dim n As Long,m As Long,FileList() As String,File As String,TempList() As String
	DirPath = Trim$(DirPath)
	If DirPath = "" Or (DefaultFile = "" And FindFile = "") Then
		ReDim List(0) As FILE_LIST,FileList(0) As String
		GetFiles = FileList
		Exit Function
	End If
	If Right$(DirPath,1) <> "\" Then DirPath = DirPath & "\"
	If DefaultFile <> "" Then
		DefaultFile = Mid$(DefaultFile,InStrRev(DefaultFile,"\") + 1)
	End If
	m = 20
	ReDim List(m) As FILE_LIST,FileList(m) As String
	If Mode = True Then
		List(0).sName = DefaultFile
		List(0).FilePath = DirPath & DefaultFile
		FileList(0) = DefaultFile
		n = 1
	End If
	DefaultFile = LCase$(DefaultFile): FindFile = LCase$(FindFile)
	File = Dir$(DirPath & "*.*")
	Do While File <> ""
		If n > m Then
			m = m * 2
			ReDim Preserve List(m) As FILE_LIST,FileList(m) As String
		End If
		If DefaultFile <> "" Then
			If LCase$(File) Like DefaultFile Then
				If Mode = True Then GoTo NextNum
				List(n).sName = File
				List(n).FilePath = DirPath & File
				FileList(n) = File
				n = n + 1
				GoTo NextNum
			End If
		End If
		If FindFile <> "" Then
			If LCase$(File) Like FindFile Then
				List(n).sName = File
				List(n).FilePath = DirPath & File
				FileList(n) = File
				n = n + 1
				GoTo NextNum
			End If
		End If
		NextNum:
		File = Dir$()
	Loop
	If n > 0 Then n = n - 1
	ReDim Preserve List(n) As FILE_LIST,FileList(n) As String
	GetFiles = FileList
End Function


'ȡǰļеļеļб
'FindFile = "" ʱ .sName = ļĿ¼ .sName = Ŀ¼еļ
Private Function getSubFiles(List() As FILE_LIST,ByVal DirPath As String,Optional ByVal DefaultFile As String,Optional ByVal FindFile As String) As String()
	Dim i As Long,j As Long,n As Long,m As Long
	Dim File As String,PathList() As String,FileList() As String,TempList() As String
	DirPath = Trim$(DirPath)
	If DirPath = "" Or (DefaultFile = "" And FindFile = "") Then
		ReDim List(0) As FILE_LIST,FileList(0) As String
		getSubFiles = FileList
		Exit Function
	End If
	If Right$(DirPath,1) <> "\" Then DirPath = DirPath & "\"
	If Dir$(DirPath & "*.*",vbDirectory) = "" Then
		ReDim List(0) As FILE_LIST,FileList(0) As String
		Exit Function
	End If
	If DefaultFile <> "" Then
		DefaultFile = LCase$(Mid$(DefaultFile,InStrRev(DefaultFile,"\") + 1))
	End If
	If FindFile <> "" Then FindFile = LCase$(FindFile)
	ReDim PathList(0) As String
	PathList(0) = DirPath
	m = 20
	ReDim List(m) As FILE_LIST,FileList(m) As String
	Do
		DirPath = PathList(i)
		File = Dir$(DirPath & "*.*",vbDirectory)
		While File <> ""
			If File <> "." And File <> ".." Then
				If GetAttr(DirPath & File) And vbDirectory Then
					j = j + 1
					ReDim Preserve PathList(j) As String
					PathList(j) = DirPath & File & "\"
				ElseIf DirPath <> PathList(0) Then
					If n > m Then
						m = m * 2
						ReDim Preserve List(m) As FILE_LIST,FileList(m) As String
					End If
					If DefaultFile <> "" Then
						If LCase$(File) Like DefaultFile Then
							If FindFile = "" Then
								TempList = ReSplit(DirPath,"\")
								List(n).sName = TempList(UBound(TempList) - 1)
							Else
								List(n).sName = File
							End If
							List(n).FilePath = DirPath & File
							FileList(n) = List(n).sName
							n = n + 1
							GoTo NextNum
						End If
					End If
					If FindFile <> "" Then
						If LCase$(File) Like FindFile Then
							List(n).sName = File
							List(n).FilePath = DirPath & File
							FileList(n) = List(n).sName
							n = n + 1
							GoTo NextNum
						End If
					End If
				End If
				NextNum:
			End If
			File = Dir$()
		Wend
		i = i + 1
	Loop Until i = j + 1
	If n > 0 Then n = n - 1
	ReDim Preserve List(n) As FILE_LIST,FileList(n) As String
	getSubFiles = FileList
End Function
