''This is to check or modify or delete if the access keys
''at end of tranlation strings are the same as in
''source strings and if not change to the same.
''Please use it only when you exactly know what it does!
''(c) 2007-2008 by gnatix (Last modified on 2008.02.24)
''2009-2019 Modified by wanfu (Last modified on 2019.04.14)

'#Uses ".\Module\modCheckCommon.bas"

Option Explicit


' 
Public Sub PSL_OnEditTransString(TransString As PslTransString)
	Dim i As Long,j As Long,n As Long,Obj As Object,Temp As String,Stemp As Boolean
	Dim MsgList() As String,TempList() As String

	'רõûǷڣڼ˳
	Set trn = TransString.TransList
	If Not trn Is Nothing Then
		If trn.Property(19980) = "CheckAccessKeys" Then Exit Sub
	End If

	'δ롢ֻΪյִ
	If TransString.SourceText = TransString.Text Then Exit Sub
	If TransString.State(pslStateTranslated) = False Then Exit Sub
	If TransString.State(pslStateLocked) = True Then Exit Sub
	If TransString.State(pslStateReadOnly) = True Then Exit Sub
	If Trim(TransString.SourceText) = "" Then Exit Sub
	If Trim(TransString.Text) = "" Then Exit Sub

	'ϵͳ
	On Error Resume Next
	Set Obj = CreateObject("WScript.Shell")
	If Obj Is Nothing Then
		PSL.Output Err.Description & " - " & "WScript.Shell"
		Exit Sub
	End If
	Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\Default"
	OSLanguage = Obj.RegRead(Temp)
	If OSLanguage = "" Then
		Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\InstallLanguage"
		OSLanguage = Obj.RegRead(Temp)
		If Err.Source = "WshShell.RegRead" Then
			PSL.Output Err.Description
			Exit Sub
		End If
	End If
	Set Obj = Nothing
	' Adodb.Stream Ƿ
	Set Obj = CreateObject("Adodb.Stream")
	If Obj Is Nothing Then
		PSL.Output Err.Description & " - " & "Adodb.Stream"
		Exit Sub
	End If
	Set Obj = Nothing
	' Scripting.Dictionary Ƿ
	Set Obj = CreateObject("Scripting.Dictionary")
	If Obj Is Nothing Then
		PSL.Output Err.Description & " - " & "Scripting.Dictionary"
		Exit Sub
	End If
	Set Obj = Nothing
	' VBScript.RegExp Ƿ
	Set RegExp = CreateObject("VBScript.RegExp")
	If RegExp Is Nothing Then
		PSL.Output Err.Description & " - " & "VBScript.RegExp"
		Exit Sub
	End If
	On Error GoTo SysErrorMsg

	'ʼ
	ReDim Tools(3) As TOOLS_PROPERTIE,FileDataList(0) As String
	ReDim UIFileList(0) As UI_FILE,UIDataList(0) As INIFILE_DATA
	ReDim cSelected(26) As String,UpdateSet(5) As String,LFList(0) As LOG_FONT
	ReDim DefaultCheckList(1) As String,CheckList(0) As CHECK_SET,CheckList(0).LangPairList(0) 'As LANG_SET
	ReDim DefaultProjectList(4) As String,ProjectList(0) As CHECK_PROJECT_SET
	ReDim CheckCountList(6) As Integer,PslLangList(0) As LANG_SET

	'ת HEX ֵַΪ Long ʽģ壬תıת
	MsgList = ReSplit(ConvertStrHexRange,";")
	ReDim CheckHexStr(UBound(MsgList)) As CHECK_STRING_VALUE
	For i = 0 To UBound(MsgList)
		CheckHexStr(i).Range = Replace$(MsgList(i),",","")
		If i = 0 Then
			CheckHexStr(i).Range = "\\x[" & CheckHexStr(i).Range & "]{2}"
		ElseIf i = 1 Then
			CheckHexStr(i).Range = "\\u[" & CheckHexStr(i).Range & "]{4}"
		ElseIf i = 2 Then
			CheckHexStr(i).Range = "\\[" & CheckHexStr(i).Range & "]+"
		End If
		CheckHexStr(i).AscRange = "[" & Convert(Replace$(MsgList(i),",","")) & "]"
	Next i

	'תֵַΪʽģ壬ıʽȽ
	CheckSkipStr = ReSplit("[" & Replace$(Replace$(CheckStrHexRange,";","];["),",","]|[") & "]",";")

	'ȡ
	GetCheckSet("Option","")

	'ȡִ
	If GetUI(MacroLoc & "\Data\",cSelected(0),OSLanguage,UIDataList,UIFileList,LangFile) = False Then Exit Sub
	If getMsgList(UIDataList,MsgList,"Main",0) = False Then Exit Sub

	' PSL 汾
	If PSL.Version < 600 Then
		PSL.Output MsgList(0) & ":" & MsgList(1)
		Exit Sub
	End If

	'ȡִ
	TempList = ReSplit(MsgList(4),";")
	DefaultCheckList(0) = TempList(0)
	DefaultCheckList(1) = TempList(1)
	TempList = ReSplit(MsgList(5),";")
	DefaultProjectList(0) = TempList(0)
	DefaultProjectList(1) = TempList(1)
	DefaultProjectList(2) = TempList(2)
	DefaultProjectList(3) = TempList(3)
	DefaultProjectList(4) = TempList(4)
	GetCheckSet("","")

	'ֹͣťʱʾԻϵϢ
	StopTitle = MsgList(27)
	StopMsg = MsgList(28)

	'ȡַб
	CodeList = getCodePageList(0,49)

	'鷭
	If UBound(CheckList) >= 0 Then
		If CheckCheckSet(CheckList) = False Then
			n = -1
		Else
			n = UBound(CheckList)
		End If
		For i = 0 To UBound(DefaultCheckList)
			Stemp = False
			For j = 0 To n
				If CheckList(j).Name = DefaultCheckList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve CheckList(n) As CHECK_SET
				CheckList(n) = DefaultCheckSet(DefaultCheckList(i),False)
				CheckList(n).Name = DefaultCheckList(i)
				CheckList(n).LangPairList = LangCodeList(DefaultCheckList(i),1,-1)
			End If
		Next i
		If CheckCheckSet(CheckList) = False Then
			PSL.Output MsgList(26) & ":" & MsgList(29)
			Exit Sub
		End If
	End If
	'鷭鷽
	If UBound(ProjectList) >= 0 Then
		If CheckArray(getSetNameList(ProjectList)) = False Then
			n = -1
		Else
			n = UBound(ProjectList)
		End If
		For i = 0 To UBound(DefaultProjectList)
			Stemp = False
			For j = 0 To n
				If ProjectList(j).Name = DefaultProjectList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve ProjectList(n) As CHECK_PROJECT_SET
				ProjectList(n) = DefaultCheckSet(DefaultProjectList(i),True)
				ProjectList(n).Name = DefaultProjectList(i)
			End If
		Next i
		If CheckArray(getSetNameList(ProjectList)) = False Then
			PSL.Output MsgList(26) & ":" & MsgList(30)
			Exit Sub
		End If
	End If

	'ʼ
	CheckStrings(TransString)
	Call ExitMacro(0)
	Exit Sub

	'ʾϢ
	SysErrorMsg:
	If Err.Source <> "ExitSub" Then Call sysErrorMassage(Err,0,True)
	Call ExitMacro(0)
End Sub


'ַ
Private Function CheckStrings(TransString As PslTransString) As Long
	Dim i As Long
	Dim srcString As String,trnString As String
	Dim MsgList() As String,LangPair As LANG_SET
	Dim LineMsg As String,AcckeyMsg As String
	Dim Stemp As Boolean
	If getMsgList(UIDataList,MsgList,"Main",1) = False Then Exit Function

	'תΪֵ
	ReDim SetList(UBound(cSelected)) As Integer
	For i = 3 To UBound(cSelected)
		Select Case i
		Case 6
			SetList(i) = 1
		Case 7 - 13
			SetList(i) = 0
		Case Else
			SetList(i) = StrToLong(cSelected(i))
		End Select
	Next i

	'ȡĿ
	With LangPair
		.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
		If .UseCode = "zh" Or .UseCode = "ja" Or .UseCode = "ko" Then .Name = "Asia"
		If .UseCode = "" Or .UseCode = "zh" Then
			.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
			Select Case .UseCode
			Case "zh-CHS" ,"zh-SG"
				.UseCode = "zh-CN"
			Case "zh-CHT", "zh-HK", "zh-MO"
				.UseCode = "zh-TW"
			End Select
		Else
			.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
		End If
	End With

	'ȡõķ
	SetList(1) = -1
	If SetList(4) = 1 Then
		SetList(1) = getCheckID(CheckList,LangPair.UseCode,LangPair.Name)
	Else
		For i = 0 To UBound(CheckList)
			If CheckList(i).Name = cSelected(1) Then
				SetList(1) = i
				Exit For
			End If
		Next i
		If SetList(1) = -1 Then
			SetList(1) = getCheckID(CheckList,LangPair.UseCode,LangPair.Name)
		End If
	End If
	If SetList(1) = -1 Then Exit Function

	'ִΪȫ
	cSelected(14) = "1"

	'תеתֵ
	CheckList(SetList(1)) = ConvertAndSortCheckSet(CheckList(SetList(1)))

	'õļ鷽
	If SetList(5) > UBound(ProjectList) Then SetList(5) = 0

	'תת
	With TransString
		Stemp = False
		trnString = .Text
		srcString = Convert(.SourceText)
		If srcString <> .SourceText Then
			trnString = Convert(trnString)
			Stemp = True
		End If

		'ʼִ
		trnString = CheckHanding(SetList(1),SetList(5),srcString,trnString)
		If SetList(25) = 1 Then trnString = ReplaceStr(SetList(1),trnString,2,1)
		If Stemp = True Then trnString = ReConvert(trnString)

		'Ϣ
		If trnString <> .Text Then
			If SetList(5) < 2 Or SetList(5) > 4 Then
				'
				StringSrc.LineNum = LineCount(.SourceText)
				StringTrn.LineNum = LineCount(trnString)
				'Ϣ
				LineMsg = LineErrMassage(StringSrc.LineNum,StringTrn.LineNum,CheckCountList(5))
				AcckeyMsg = AccKeyErrMassage(StringSrc.AccKeyNum,StringTrn.AccKeyNum,CheckCountList(6))
			End If
			.OutputError CheckMassage(SetList(1),SetList(5)) & AcckeyMsg & LineMsg
			'滻ִ
			If ProjectList(SetList(5)).ShowOriginalTran = 1 Then .OutputError(Replace(MsgList(22),"%s",.Text))
			.Text = trnString
			CheckStrings = CheckStrings + 1
		End If
	End With
End Function
